//
//  LabResult.m
//  PatientViewer
//
//  Created by Grant Oladipo on 2/28/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "LabResult.h"

@implementation LabResult

-(id)noPropertyValue {
	return nil;
}

-(BOOL)abnormalIndicatorFlag {
	
	if ([[self propertyValueForKey:LabResultAbnormalIndicatorFlagKey] isEqualToString:@"false"]) {
		return NO;
	} else {
		return YES;
	}
}

-(NSString *)abnormalIndicatorTriFlag {
	return [self propertyValueForKey:LabResultAbnormalIndicatorTriFlagKey];
}

-(NSString *)indicator {
	return [self propertyValueForKey:LabResultIndicatorKey];
}

-(NSString *)referenceHigh {
	return [self propertyValueForKey:LabResultReferenceHighKey];
}

-(NSString *)referenceLow {
	return [self propertyValueForKey:LabResultReferenceLowKey];
}

-(NSDate *)resultedDate {
    
    if  (initialDateFormat) {
        initialDateFormat = NO;
        formattedResultDate = [[dateFormatter dateFromString:[self propertyValueForKey:LabResultResultedDateKey]] retain];
      return  [dateFormatter dateFromString:[self propertyValueForKey:LabResultResultedDateKey]];
    } else {
        return formattedResultDate;
    }
}

-(NSString *)value {
	return [self propertyValueForKey:LabResultValueKey];
}

-(NSString *)valueUnits {
	return [self propertyValueForKey:LabResultValueUnitKey];
}

-(NSString *)testName {
	return [self propertyValueForKey:LabResultTestNameKey];
}

-(NSString *)specimen {
    
	return [self propertyValueForKey:LabResultSpecimenNameKey];
}

-(NSString *)displayName {
    
	return [self propertyValueForKey:LabResultDisplayNameKey];
}


-(id)initWithAttributeDictionary:(NSDictionary *)attributeDict {
    
    self = [super initWithAttributeDictionary:attributeDict];
    if (self) {
        dateFormatter = [[NSDateFormatter alloc] init];
        [dateFormatter setDateFormat:@"MM/dd/yyyy HH:mm:ss"];
        initialDateFormat = YES;
        formattedResultDate = [[NSDate alloc] init];
    }
    return self;
    
    
}

-(void)dealloc{
    [dateFormatter release], dateFormatter = nil;
    [formattedResultDate release], formattedResultDate = nil;
    [super dealloc];
}
@end