//
//  Document.h
//  iOSiCADLibrary
//
//  Created by Grant Oladipo on 1/7/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "Resource.h"

//Property keys
#define	MedicationDrugNameKey		@"drugName"
#define	MedicationStartDateKey		@"startDate"
#define	MedicationEndDateKey		@"endDate"
#define MedicationSourceKey			@"medicationSource"
#define MedicationQuantityKey       @"quantity"
#define MedicationDaysSupplyKey     @"daysSupply"
#define MedicationLastFilledDateKey	@"lastFilledDate"
#define MedicationSigKey            @"sig"
#define MedicationRefillKey         @"refills"
#define MedicationDetailKey         @"medicationDetail"
#define MedicationStatusKey         @"status"

//Atom Link keys
#define MedicationDetailLinkKey     @"related/patient-medication-detail"

@interface Medication : Resource {
    NSDateFormatter *dateFormatter;
    BOOL initialStartDateFormat;
    NSDate *formattedStartDate;
    BOOL initialEndDateFormat;
    NSDate *formattedEndDate;

}

-(NSString *)daysSupply;
-(NSString *)displayQuantity;
-(NSString *)drugName;
-(NSDate *)endDate;
-(NSString *)lastFilledDate;
-(NSString *)medicationDetail;
-(NSString *)medicationSource;
-(NSString *)refill;
-(NSString *)sig;
-(NSDate *)startDate;
-(NSString *)status;
-(NSString *)quantity;

@end