//
//  Document.m
//  iOSiCADLibrary
//
//  Created by Grant Oladipo on 1/7/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "Medication.h"

@implementation Medication

-(id)noPropertyValue {
	return nil;
}

-(NSString *)status {
    return [self propertyValueForKey:MedicationStatusKey];
}

-(NSString *)medicationDetail {
    return [self propertyValueForKey:MedicationDetailKey];
}

-(NSString *)daysSupply {
    return [self propertyValueForKey:MedicationDaysSupplyKey];
}

-(NSString *)quantity {
    return [self propertyValueForKey:MedicationQuantityKey];

}

-(NSString *)refill {
    return [self propertyValueForKey:MedicationRefillKey];
}

-(NSString *)lastFilledDate {	
	return [self propertyValueForKey:MedicationLastFilledDateKey];
}

-(NSString *)sig {
    return [self propertyValueForKey:MedicationSigKey];

}

-(NSString *)drugName {
	return [self propertyValueForKey:MedicationDrugNameKey];
}

-(NSString *)displayQuantity {
	
	if ([self quantity] && ![[self quantity] isEqualToString:@""] && [self daysSupply] && ![[self daysSupply] isEqualToString:@""]) {
		return [NSString stringWithFormat:@"%@ for %@ days", [self quantity], [self daysSupply]];
	}
	
	return @"";
}

-(NSDate *)startDate {
	
    if (initialStartDateFormat) {
        initialStartDateFormat = NO;
        formattedStartDate = [[dateFormatter dateFromString:[self propertyValueForKey:MedicationStartDateKey]] retain];
    }
    
    return formattedStartDate;
//    
//	NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
//	[dateFormatter setDateFormat:@"MM/dd/yyyy HH:mm:ss"];
//	NSDate *date = [dateFormatter dateFromString:[self propertyValueForKey:MedicationStartDateKey]];
//	[dateFormatter release];
//	
//	return date;
}

-(NSDate *)endDate {
   
    if (initialEndDateFormat) {
        initialEndDateFormat = NO;
        formattedEndDate = [[dateFormatter dateFromString:[self propertyValueForKey:MedicationEndDateKey]] retain];
    }
    
    return formattedEndDate;
    
//	NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
//	[dateFormatter setDateFormat:@"MM/dd/yyyy HH:mm:ss"];
//	NSDate *date = [dateFormatter dateFromString:[self propertyValueForKey:MedicationEndDateKey]];
//	
//	if (!date) {
//        [dateFormatter release];
//		return nil;
//	}
//
//	[dateFormatter release];
//	
//	return date;
}


-(NSString *)medicationSource {
	return [self propertyValueForKey:MedicationSourceKey];
}

-(id)initWithAttributeDictionary:(NSDictionary *)attributeDict {
    
    self = [super initWithAttributeDictionary:attributeDict];
    if (self) {
        dateFormatter = [[NSDateFormatter alloc] init];
        [dateFormatter setDateFormat:@"MM/dd/yyyy HH:mm:ss"];
       
        initialStartDateFormat = YES;
        initialEndDateFormat = YES;
        
        formattedStartDate = [[NSDate alloc] init];
        formattedEndDate = [[NSDate alloc] init];
    }
    return self;
    
    
}

-(void)dealloc{
    [dateFormatter release], dateFormatter = nil;
    [formattedStartDate release], formattedStartDate = nil;

    [formattedEndDate release], formattedEndDate = nil;
    [super dealloc];
}


@end