//
//  Resource.m
//  iOSiCADLibrary
//
//  Created by Grant Oladipo on 12/23/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "Resource.h"

@implementation Resource

#pragma mark - Initializing/Refreshing
-(id)init {
	
	self = [super init];
	
	if (self) {
		properties = [[NSMutableDictionary alloc] initWithCapacity:1];
		links = [[NSMutableDictionary alloc] initWithCapacity:1];
	}
	
	return self;
}

-(id)initWithAttributeDictionary:(NSDictionary *)attributeDict {

	self = [self init];
	
	if (self) {
		[properties setValuesForKeysWithDictionary:attributeDict];
	}
	
	return self;
}

-(id)refreshWithAttributeDictionary:(NSDictionary *)attributeDict {

	[properties setValuesForKeysWithDictionary:attributeDict];
	return self;
}


#pragma mark - Atom Links
-(void)addLink:(Link *)link {
	[links setValue:link forKey:[link key]];
}

-(NSMutableDictionary *)links {
	return links;
}


#pragma mark - Property Values
-(id)noPropertyValue {
	return nil;
}

-(id)propertyValueForKey:(NSString *)key {
	
	id propertyValue = [properties valueForKey:key];
	
	if (propertyValue) {
		return propertyValue;
	}
	return [self noPropertyValue];
}

-(void)removeAllProperties {
	[properties removeAllObjects];
}

-(void)removeAllLinks {
	[links removeAllObjects];
}

-(void)setPropertyValue:(id)value forKey:(NSString *)key {
	
	[properties setValue:value forKey:key];
}


#pragma mark - Description
-(NSString *)description {

	NSMutableString *description = [NSMutableString stringWithCapacity:1];
	
	[description appendFormat:@"%@ - %@: {", [super description], [self class]];
	
	[description appendFormat:@"Properties: %@ \n", properties];
	[description appendFormat:@"Links: %@ \n", links];
		
	[description appendString:@"}"];
	
	return description;	
}


#pragma mark - Memory Management
-(void)dealloc {
	
	[properties release], properties = nil;
	[links release], links = nil;
	[super dealloc];
}

@end