//
//  UserSession.h
//  PatientViewer
//
//  Created by Grant Oladipo on 3/1/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "Resource.h"

//Property Keys
#define UserSessionSessionIdKey		@"sessionId"
#define UserSessionMHPUserKey		@"mhpUser"
#define UserSessionCredentialKey	@"credential"
#define UserSessionClientTimeoutKey	@"clientTimeout"

//User Session Cache Keys
#define UserSessionCurrentMedicationsKey	@"currentMedication"
#define UserSessionSelectedLabTestKey		@"selectedLabTest"
#define UserSessionSelectedMedicationKey	@"selectedMedication"
#define UserSessionSelectedPatientKey		@"patient"
#define UserSessionTimeStampKey				@"timeStamp"
#define UserSessionSelectedLabResultKey     @"selectedLabResult"

//Atom link keys
#define UserSessionPatientSearchURILinkKey		@"related/patients"

//Notifications
#define UserSessionWillChangePatient			@"willChangePatient"
#define UserSessionDidChangePatient				@"didChangePatient"
#define UserSessionWillChangeLabTest			@"willChangeLabTest"
#define	UserSessionDidChangeLabTest				@"didChangeLabTest"
#define UserSessionWillChangeMedication			@"willChangeMedication"
#define	UserSessionDidChangeMedication			@"didChangeMedication"
#define UserSessionWillChangeCurrentMedications	@"willChangeCurrentMedications"
#define	UserSessionDidChangeCurrentMedications	@"didChangeCurrentMedications"
#define UserSessionWillChangeLabResult          @"willChangeLabResult"
#define UserSessionDidChangeLabResult           @"didChangeLabResult"
#define UserSessionShowChemTest             @"didShowChemTest"
#define UserSessionShowMicroResults             @"didShowMicroResult"



//Constant
#define UserSessionNoTimeOutSetValue	-1.0
#define UserSessionHasTimedOutValue		-2.0
#define SixtySeconds                      60

@class Patient;
@class LabTest;
@class Medication;
@class MHPUser;
@class LabResult;


@interface UserSession : Resource {
}


@property (nonatomic, retain) UILocalNotification *sessionExpireNotifcation;


+(id)currentUserSession;

+(void)removeSelectedPatient;
+(id)selectedPatient;
+(void)setSelectedPatient:(Patient *)aPatient;

+(void)removeSelectedLabTest;
+(id)selectedLabTest;
+(void)setSelectedLabTest:(LabTest *)aLabTest;

+(void)removeSelectedLabResult;
+(id)selectedLabResult;
+(void)setSelectedLabResult:(LabResult *)aLabResult;

+(void)showMicroResults;
+(void)showChemTest;


+(void)updateSelectedMedicationWithPropertyValue:(id)value forKey:(NSString*)key;

+(void)removeSelectedMedication;
+(id)selectedMedication;
+(void)setSelectedMedication:(Medication *)aMedication;

+(void)removeCurrentMedications;
+(id)currentMedications;
+(void)setCurrentMedications:(NSArray *)theCurrentMedications;

+(NSURLCredential *)credential;
+(void)setCredential:(NSURLCredential *)aCredential;

+(MHPUser *)mhpUser;
+(void)setMHPUser:(MHPUser *)anMHPUser;

+(void)setTimeStamp:(NSDate *)newTimeStamp;

+(NSString *)clientTimeout;

+(BOOL)enforceTimeout;
+(void)reset;

+(NSString *)sessionId;

@end