//
//  iOSiCADPatientManager.m
//  iOSiCADLibrary
//
//  Created by Grant Oladipo on 12/15/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "Allergy.h"
#import "AllergyManager.h"
#import "AllergyParser.h"
#import "Link.h"
#import "Patient.h"
#import "PatientMainContainer.h"

@implementation AllergyManager


#pragma mark - Custom Accessors
-(void)allergiesForPatient:(Patient *)patient result:(id<AllergyContainer>)theAllergyContainer {
	
	[allergyContainer release];
	allergyContainer = [theAllergyContainer retain];
	
	[self fetchResourceWithURL:[[[patient links] objectForKey:PatientAllergiesLinkKey] href]];
}

-(AllergyParser *)parser {
	return [[[AllergyParser alloc] initWithDelegate:allergyContainer] autorelease];
}


#pragma mark - Initialization
+(id)allergyManager {
	
	AllergyManager *allergyManager = [[AllergyManager alloc] init];
	
	return [allergyManager autorelease];
}


#pragma mark - Memory Management
-(void)dealloc {

	[allergyContainer release], allergyContainer = nil;
	
	[super dealloc];
}

@end