//  Connection.h
//  PatientViewer
//
//  Created by Grant Oladipo on 5/9/11.
//  xxxxxxxxx xxxx xxxxxxx xxx xxxxxx xxxxxxxxx

#import "Parser.h"

#define ConnectionTimeoutInterval		60.0f
#define ConnectionHealthCheckFailed		@"connectionHealthCheckFailed"
#define ConnectionHealthCheckSucceeded	@"connectionHealthCheckSucceeded"

#define	ConnectionShouldWipeData		@"wipeData"

@protocol Connection <NSObject>

@required
-(void)getWithURL:(NSURL *)URL usingParser:(id<Parser>)parser;
-(void)performHealthCheck;
-(void)postWithURL:(NSURL *)URL withPostBodyString:(NSString *)postBody;
-(NSInteger)statusCodeForURL:(NSURL *)URL usingMethod:(NSString *)method;

@end