//  Connection.m
//  Patient Viewer
//
//  Created by Grant Oladipo on 2/9/11.
//  xxxxxxxxx xxxx xxxxxxx xxx xxxxxx xxxxxxxxx

#import "ApplicationProperty.h"
#import "ASIConnection.h"
#import "ConnectionFactory.h"
#import "IOSConnection.h"
#import "FileConnection.h"

@implementation ConnectionFactory


#pragma mark - Custom Accessors
+(id)connection {
	
	id<Connection> newConnection;
	
	if ([[ApplicationProperty connectionLibraryString] isEqualToString:@"IOSConnection"]) {
		newConnection = [[IOSConnection alloc] init];
	} else if ([[ApplicationProperty connectionLibraryString] isEqualToString:@"FileConnection"]) {
            newConnection = [[FileConnection alloc] init];
    } else {
		newConnection = [[ASIConnection alloc] init];
	}
	
	return [newConnection autorelease];
}


#pragma mark - Memory Management
-(void)dealloc {
	[super dealloc];
}

@end