//
//  DemographicManager.m
//  PatientViewer
//
//  Created by Grant Oladipo on 2/10/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "Address.h"
#import "Demographics.h"
#import "DemographicsManager.h"
#import "DemographicsParser.h"
#import "Link.h"
#import "NextOfKin.h"
#import "Patient.h"

@implementation DemographicsManager


#pragma mark - Custom Accessors
-(void)demographicsForPatient:(Patient *)patient result:(id<DemographicsContainer>)theDemographicsContainer {
	
	[demographicsContainer release];
	demographicsContainer = [theDemographicsContainer retain];
	
	[self fetchResourceWithURL:[[[patient links] objectForKey:PatientDemographicsLinkKey] href]];
}

-(DemographicsParser *)parser {
	return [[[DemographicsParser alloc] initWithDelegate:demographicsContainer] autorelease];
}


#pragma mark - Initialization
+(id)demographicsManager {
	
	DemographicsManager *demographicsManager = [[DemographicsManager alloc] init];
	
	return [demographicsManager autorelease];
}


#pragma mark - Memory Management
-(void)dealloc {
	
	[demographicsContainer release], demographicsContainer = nil;
	
	[super dealloc];
}



@end