#import "AppDelegate.h"
#import "FileConnection.h"
#import "UserSession.h"

#define Http_Success_Code 200

@implementation FileConnection

-(void)postWithURL:(NSURL *)URL withPostBodyString:(NSString *)postBody {
	
}

-(void)getWithURL:(NSURL *)URL usingParser:(id<Parser>)newParser {
	
	[[NSNotificationCenter defaultCenter] postNotificationName:ApplicationDidMakeMHPRequest object:self];
	
	[parser release];
	parser = [newParser retain];

	NSString *extension = @"xml";
	NSString *resource = [URL absoluteString]; 
        
    NSRange range = [resource rangeOfString:@"patient-image"];

    if (range.location != NSNotFound) {
        extension = @"jpg";
	}
    
    NSString *queryStringKey = @"?searchString=";
    
    range = [[URL relativeString] rangeOfString:queryStringKey];
    
    if (range.location != NSNotFound){

        NSString *searchParam = [[URL relativeString] substringFromIndex:range.location + queryStringKey.length];
        
        if ([validSearchStrings containsObject:searchParam]){
            resource = [NSString stringWithFormat:@"%@%@", [[URL baseURL] absoluteString],[URL relativeString]]; 
        }else{
            resource = [NSString stringWithFormat:@"patient_not_found"]; 
        }
    }
    
    NSLog(@"resource %@", resource);

    resource = [resource stringByReplacingOccurrencesOfString:@"/" withString:@"_"];
    resource = [resource stringByReplacingOccurrencesOfString:@"?" withString:@"_"];
    resource = [resource stringByReplacingOccurrencesOfString:@"=" withString:@"_"];
    NSLog(@"resource %@", resource);

	NSURLRequest *request = [NSURLRequest requestWithURL:[[NSBundle bundleForClass:[self class]] URLForResource:resource withExtension:extension]];
   
    NSLog(@"%@ ",[[NSBundle bundleForClass:[self class]] URLForResource:resource withExtension:extension]);
	
    NSData *data = [NSURLConnection sendSynchronousRequest:request returningResponse:NULL error:NULL];
    
    [parser parseData:data];
    
	[[NSNotificationCenter defaultCenter] postNotificationName:ApplicationDidFinishProcessingMHPResponse object:self];
}

-(NSInteger)statusCodeForURL:(NSURL *)URL usingMethod:(NSString *)method {
    
	return Http_Success_Code;
}

-(void)performHealthCheck {

	[[NSNotificationCenter defaultCenter] postNotificationName:ConnectionHealthCheckSucceeded object:self userInfo:nil];
	
	AppDelegate *delegate = (AppDelegate *)[[UIApplication sharedApplication] delegate];
	[delegate hideProgressNotifier];
}

#pragma mark - init
-(id) init {
    self = [super init];
    
    if (self){
        validSearchStrings = [[NSMutableArray alloc] initWithObjects:@"one", nil];
    }
    
    return self;
}

#pragma mark - Memory Management
-(void)dealloc {
	
	[parser release], parser = nil;
    [validSearchStrings release], validSearchStrings = nil;
	[super dealloc];
}
@end