//
//  ImageManager.m
//  MobileHealthiOSPlatformLibrary
//
//  Created by Grant Oladipo on 1/28/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "ImageManager.h"
#import "ImageParser.h"
#import "Link.h"
#import "Patient.h"

@implementation ImageManager


#pragma mark - Custom Accessors
-(void)patientImageForPatient:(Patient *)patient result:(id<ImageContainer>)theImageContainer {
	
	[imageContainer release];
	imageContainer = [theImageContainer retain];
	
	[self fetchResourceWithURL:[[[patient links] objectForKey:PatientImageLinkKey] href]];
}


#pragma mark - Custom Methods
-(ImageParser *)parser {
	return [[[ImageParser alloc] initWithDelegate:imageContainer] autorelease];
}



#pragma mark - Initialization
+(id)imageManager {
	
	ImageManager *imageManager = [[ImageManager alloc] init];
	
	return [imageManager autorelease];
}


#pragma mark - Memory Management
-(void)dealloc {
	
	[imageContainer release], imageContainer = nil;
	
	[super dealloc];
}

//
//#pragma mark - NSURLConnectionDelegate
//-(void)connectionDidFinishLoading:(NSURLConnection *)connection {
//		
//	[self createImageWithData:receivedData];
//	[super connectionDidFinishLoading:connection];
//}

@end


