#import "CorePlot-CocoaTouch.h"
#import "LabMainContainerDelegate.h"

@class LabTest;
@class LabMainContainer;

@interface LabMain : UIViewController <CPBarPlotDataSource, CPBarPlotDelegate, CPPlotDataSource, LabMainContainerDelegate, UIScrollViewDelegate, UIGestureRecognizerDelegate, CPPlotSpaceDelegate> {

	IBOutlet CPGraphHostingView *scatterPlotGHV;
	IBOutlet CPGraphHostingView *histogramGHV;
	
	IBOutlet UIView *graphBackgroundV;
	
	IBOutlet UIButton *inpatientB;
	IBOutlet UIButton *outpatientB;
	
	IBOutlet UILabel *labTestNameL;
	IBOutlet UILabel *noMedicationsL;
	IBOutlet UILabel *noLabsL;
	IBOutlet UILabel *dateLabel;
    
	IBOutlet UIButton *dayB;
	IBOutlet UIButton *weekB;
	IBOutlet UIButton *monthB;
	IBOutlet UIButton *yearB;
	IBOutlet UIButton *twoYearB;
	IBOutlet UIButton *allB;
	
	NSMutableArray *dataForHistogram;
	NSMutableArray *dataForScatterPlot;
	CPXYGraph *histogramGraph;
	LabMainContainer *labTestGraphContainer;
	NSDate *refDate;
	CPXYGraph *scatterPlotGraph;
    
    CGFloat xUnit;
    CGFloat yUnit;
	
	BOOL shouldRefresh;
}

@property(nonatomic, retain) IBOutlet UITextView *labResultTV;

@property(nonatomic, retain) IBOutlet UILabel *labTestNameL;
@property(nonatomic, retain) IBOutlet UILabel *noMedicationsL;
@property(nonatomic, retain) IBOutlet UILabel *noLabsL;

@property(nonatomic, retain) IBOutlet UIButton *inpatientB;
@property(nonatomic, retain) IBOutlet UIButton *outpatientB;

@property(nonatomic, retain) IBOutlet UIScrollView *histogramSV;
@property(nonatomic, retain) IBOutlet CPGraphHostingView *scatterPlotGHV;
@property(nonatomic, retain) IBOutlet CPGraphHostingView *histogramGHV;

@property(nonatomic, retain) LabMainContainer *labTestGraphContainer;
@property(nonatomic, retain) CPXYGraph *histogramGraph;

@property(nonatomic) CGFloat xUnit;
@property(nonatomic) CGFloat yUnit;
@property(nonatomic, retain) NSDateFormatter *dateFormatter;

@property(nonatomic, retain) CPXYGraph *scatterPlotGraph;


-(void)checkMedications;
-(void)checkInpatientMedications;
-(void)checkOutpatientMedications;


-(void)clearGraphs;


-(CGFloat)getBufferForValue:(CGFloat)value;

-(IBAction)showDayRange:(id)sender;
-(IBAction)showWeekRange:(id)sender;
-(IBAction)showMonthRange:(id)sender;
-(IBAction)showYearRange:(id)sender;
-(IBAction)showTwoYearRange:(id)sender;
-(IBAction)showAllRange:(id)sender;

-(IBAction)showInpatientHistogram:(id)sender;
-(IBAction)showOutpatientHistogram:(id)sender;
-(void)reloadHistogramGraph;
-(void)showLabTest:(LabTest *)theLabTest;


-(void)setPaddingForGraph:(CPXYGraph *)graph;

-(void)setGraphIntervals;
-(void)setGraphAxes;
-(void)setReferenceRanges;

-(void)clearPlotAnnotations;
-(void)drawVerticalSelectionLineInSpace:(CPPlotSpace *)space withEvent:(id)event atPoint:(CGPoint)point;
-(void)addLineAnnotationToPlot:(CPPlot *)plot withAnchorPointArray:(NSArray *)anchorPointArray withIndex:(NSUInteger)index;
-(void)addPointSymbolToPlot:(CPPlot *)plot withAnchorPointArray:(NSArray *)anchorPointArray;
-(void)addTextAnnotationsToPlot:(CPPlot *)plot atIndex:(NSUInteger)index withAnchorPointArray:(NSArray *)anchorPointArray;

-(void)hideGraphs;
-(CGFloat)getGraphWidth;

-(void)processDidChangePatient:(NSNotification *)notification;
-(void)processDidChangeLabTest:(NSNotification *)notification;
-(void)processDidChangeLabResult:(NSNotification *)notification;
-(void)processDidShowChemTest:(NSNotification *)notification;
-(void)processDidShowMicroResult:(NSNotification *)notification;

@end