//  LabViewerAppViewController.m
//  PatientViewer
//
//  Created by Visu Patlolla on 2/25/11.
//  xxxxxxxxx xxxx xxxxxxx xxx xxxxxx xxxxxxxxxxxxxxxxxxxxxx

#import "LabTest.h"
#import "LabMainContainer.h"
#import "LabMain.h"
#import "LabResult.h"
#import "Medication.h"
#import "MedicationManager.h"
#import "MetricsPusher.h"
#import "Patient.h"
#import	"UserSession.h"

@implementation LabMain

@synthesize histogramSV;
@synthesize labTestGraphContainer;
@synthesize scatterPlotGHV;
@synthesize histogramGHV;
@synthesize histogramGraph;
@synthesize labTestNameL;
@synthesize noMedicationsL;
@synthesize noLabsL;
@synthesize inpatientB;
@synthesize outpatientB;
@synthesize xUnit;
@synthesize yUnit;
@synthesize dateFormatter;
@synthesize scatterPlotGraph;
@synthesize labResultTV;

#pragma mark - custom Methods
-(CGFloat)getGraphWidth {
//implemented in subclass
    return 0;
}

#pragma mark - CPPlotDataSource Methods
-(NSUInteger)numberOfRecordsForPlot:(CPPlot *)plot {
	
	if ([plot isKindOfClass:[CPBarPlot class]]) {
        return [labTestGraphContainer numberOfMedications];
	} else if ([(NSString *)plot.identifier isEqualToString:@"labResult"]) { 
		return [labTestGraphContainer numberOfLabResults];
	} else {
		return ([labTestGraphContainer numberOfLabResults] + 2);
	}
    
}

-(NSNumber *)numberForPlot:(CPPlot *)plot field:(NSUInteger)fieldEnum recordIndex:(NSUInteger)index {
	
	LabResult *labResult;
	NSDecimalNumber *num = nil;
	
	if ([plot isKindOfClass:[CPBarPlot class]]) {
		
		Medication *medication = [labTestGraphContainer medicationAtIndex:index];
        
        switch ( fieldEnum ) {
            case CPBarPlotFieldBarLocation:
                num = (NSDecimalNumber *)[NSDecimalNumber numberWithUnsignedInteger:index*2];
                break;
                
            case CPBarPlotFieldBarTip:
                
                if ([medication endDate]) {
                    if ([[medication endDate] timeIntervalSinceDate:[[medication startDate] laterDate:refDate]] < [labTestGraphContainer dateRange]/200) {                        
                        num = (NSDecimalNumber *)[NSDecimalNumber numberWithDouble:[labTestGraphContainer dateRange]/200 + [[[medication endDate] earlierDate:labTestGraphContainer.currentDate] timeIntervalSinceDate:refDate]]; 
                    } else {
                        num = (NSDecimalNumber *)[NSDecimalNumber numberWithDouble:[[[medication endDate] earlierDate:labTestGraphContainer.currentDate] timeIntervalSinceDate:refDate]];
                    }
                } else if ([[medication endDate] timeIntervalSinceDate:[medication startDate]] < [labTestGraphContainer dateRange]/100) {                        
                    num = (NSDecimalNumber *)[NSDecimalNumber numberWithDouble:[labTestGraphContainer dateRange]/100 + [labTestGraphContainer.currentDate timeIntervalSinceDate:refDate]];
                } else {
                    num = (NSDecimalNumber *)[NSDecimalNumber numberWithDouble:[labTestGraphContainer.currentDate timeIntervalSinceDate:refDate]];
                }
                
                break;
                
            case CPBarPlotFieldBarBase:

                num = (NSDecimalNumber *)[NSDecimalNumber numberWithDouble:[[medication startDate] timeIntervalSinceDate:refDate]];
//				num = (num < 0 ? 0 : num);
                break;
        }
        
		return num;
		
	} else {

		if ([(NSString *)plot.identifier isEqualToString:@"labResult"]) {

			labResult = [labTestGraphContainer labResultAtIndex:index];
			
			switch (fieldEnum) {
				case CPScatterPlotFieldX:
					num = (NSDecimalNumber *)[NSDecimalNumber numberWithFloat:[[labResult resultedDate] timeIntervalSinceDate:refDate]];
					break;
				case CPScatterPlotFieldY:
					num = (NSDecimalNumber *)[NSNumber numberWithFloat:[labResult.value floatValue]];
					break;
			}
		} else if ([(NSString *)plot.identifier isEqualToString:@"refHigh"]) {
			
			if (index == 0) {
				switch (fieldEnum) {
					case CPScatterPlotFieldX:
						num = (NSDecimalNumber *)[NSDecimalNumber numberWithFloat:[refDate timeIntervalSinceDate:refDate]];
						break;
					case CPScatterPlotFieldY:
						if ([labTestGraphContainer numberOfLabResults] > 0) {
                            if ([[labTestGraphContainer labResultAtIndex:0] referenceHigh] == nil) {
                                num = nil;
                            } else {
                                num = (NSDecimalNumber *)[NSNumber numberWithFloat:[[[labTestGraphContainer labResultAtIndex:0] referenceHigh] floatValue]];\
                            }
						}
						break;
				}
			} else if (index == ([labTestGraphContainer numberOfLabResults] + 1)) {
				switch (fieldEnum) {
					case CPScatterPlotFieldX:
						num = (NSDecimalNumber *)[NSDecimalNumber numberWithFloat:[labTestGraphContainer.currentDate timeIntervalSinceDate:refDate]];
						break;
					case CPScatterPlotFieldY:
						if ([labTestGraphContainer numberOfLabResults] > 0) {
                            if ([[labTestGraphContainer labResultAtIndex:(index-2)] referenceHigh] == nil) {
                                num = nil;
                            } else {
                                num = (NSDecimalNumber *)[NSNumber numberWithFloat:[[[labTestGraphContainer labResultAtIndex:(index-2)] referenceHigh] floatValue]];
                            }
						}
						break;
				}
			} else {
				labResult = [labTestGraphContainer labResultAtIndex:index-1];
				
				switch (fieldEnum) {
					case CPScatterPlotFieldX:
						num = (NSDecimalNumber *)[NSDecimalNumber numberWithFloat:[[labResult resultedDate] timeIntervalSinceDate:refDate]];
						break;
					case CPScatterPlotFieldY:
                        if ([labResult referenceHigh] == nil) {
                            num = nil;
                        } else {
                            num = (NSDecimalNumber *)[NSNumber numberWithFloat:[[labResult referenceHigh] floatValue]];
                        }
						break;
				}
			}
		} else if ([(NSString *)plot.identifier isEqualToString:@"refLow"]) {
			
			if (index == 0) {
				switch (fieldEnum) {
					case CPScatterPlotFieldX:
						num = (NSDecimalNumber *)[NSDecimalNumber numberWithFloat:[refDate timeIntervalSinceDate:refDate]];
						break;
					case CPScatterPlotFieldY:
						if ([labTestGraphContainer numberOfLabResults] > 0) {
                            if ([[labTestGraphContainer labResultAtIndex:0] referenceLow] == nil) {
                                num = nil;
                            } else {
                                num = (NSDecimalNumber *)[NSNumber numberWithFloat:[[[labTestGraphContainer labResultAtIndex:0] referenceLow] floatValue]];
                            }
						}
						break;
				}
			} else if (index == ([labTestGraphContainer numberOfLabResults] + 1)) {
				switch (fieldEnum) {
					case CPScatterPlotFieldX:
						num = (NSDecimalNumber *)[NSDecimalNumber numberWithFloat:[labTestGraphContainer.currentDate timeIntervalSinceDate:refDate]];
						break;
					case CPScatterPlotFieldY:
						if ([labTestGraphContainer numberOfLabResults] > 0) {
                            if ([[labTestGraphContainer labResultAtIndex:index-2] referenceLow] == nil) {
                                num = nil;
                            } else {
                                num = (NSDecimalNumber *)[NSNumber numberWithFloat:[[[labTestGraphContainer labResultAtIndex:index-2] referenceLow] floatValue]];
                            }
						}
						break;
				}
			} else {
				labResult = [labTestGraphContainer labResultAtIndex:index-1];
				
				switch (fieldEnum) {
					case CPScatterPlotFieldX:
						num = (NSDecimalNumber *)[NSDecimalNumber numberWithFloat:[[labResult resultedDate] timeIntervalSinceDate:refDate]];
						break;
					case CPScatterPlotFieldY:
                        if ([labResult referenceLow] == nil) {
                            num = nil;
                        } else {
                            num = (NSDecimalNumber *)[NSNumber numberWithFloat:[[labResult referenceLow] floatValue]];
                        }
						break;
				}
			}
		}
		return num;
	}
}

-(CPLayer *)dataLabelForPlot:(CPPlot *)plot recordIndex:(NSUInteger)index {
	
	static CPMutableTextStyle *whiteText = nil;
	
	if ( !whiteText ) {
		whiteText = [[CPMutableTextStyle alloc] init];
		whiteText.color = [CPColor whiteColor];
	}
	
	if ([plot isKindOfClass:[CPBarPlot class]]) {
		Medication *medication = [labTestGraphContainer medicationAtIndex:index];
		whiteText.fontName = @"Arial-BoldMT";
        whiteText.fontSize = 12.0;
        
        NSString *medName = [[medication drugName] uppercaseString];
        
        CPTextLayer *newLayer = [[[CPTextLayer alloc] initWithText:medName style:whiteText] autorelease];
        
		return newLayer;
		
	} else {

//		LabResult *labResult = [labTestGraphContainer labResultAtIndex:index];		
//		NSDecimalNumber *num = (NSDecimalNumber *)[NSNumber numberWithFloat:[labResult.value floatValue]];
//		CPTextLayer *newLayer = [[[CPTextLayer alloc] initWithText:[NSString stringWithFormat:@"%3.2f", [num doubleValue]] style:whiteText] autorelease];
//		
//		return newLayer;
		return nil;
	}
}


#pragma mark - Custom Actions
-(void)constructHistogram {
	
    histogramGraph = [[CPXYGraph alloc] initWithFrame:CGRectZero];
	histogramGHV.hostedGraph = histogramGraph;
    histogramGraph.plotAreaFrame.masksToBorder = NO;

    [self setPaddingForGraph:histogramGraph];
    
	NSTimeInterval dateRange = [labTestGraphContainer dateRange];
	
    histogramGraph.defaultPlotSpace.delegate = self;
    
    CPXYPlotSpace *plotSpace = (CPXYPlotSpace *)histogramGraph.defaultPlotSpace;
    plotSpace.yRange = [CPPlotRange plotRangeWithLocation:CPDecimalFromFloat(0.0f) length:CPDecimalFromFloat([labTestGraphContainer numberOfMedications]*2)];
	plotSpace.xRange = [CPPlotRange plotRangeWithLocation:CPDecimalFromFloat(0) length:CPDecimalFromFloat(dateRange)];
	
	CPXYAxisSet *axisSet = (CPXYAxisSet *)histogramGraph.axisSet;
	
	CPXYAxis *xaxis = axisSet.xAxis;
	xaxis.axisLineStyle = nil;
	xaxis.labelingPolicy = CPAxisLabelingPolicyNone;
	xaxis.majorTickLineStyle = nil;
    xaxis.minorTickLineStyle = nil;
	xaxis.majorIntervalLength = CPDecimalFromFloat(oneDay);
	xaxis.orthogonalCoordinateDecimal = CPDecimalFromFloat(0);
    
	CPXYAxis *yaxis = axisSet.yAxis;
    yaxis.axisLineStyle = nil;
	yaxis.labelingPolicy = CPAxisLabelingPolicyNone;
    yaxis.majorTickLineStyle = nil;
    yaxis.minorTickLineStyle = nil;
    yaxis.majorIntervalLength = CPDecimalFromString(@"1");
    yaxis.orthogonalCoordinateDecimal = CPDecimalFromString(@"0");
	
	CPBarPlot *barPlot = [CPBarPlot tubularBarPlotWithColor:[CPColor colorWithComponentRed:250.0 green:130.0 blue:20.0 alpha:1.0] horizontalBars:YES];	
	barPlot.identifier = @"medicine";
	barPlot.barBasesVary = YES;
	barPlot.barOffset = 0.375f;
	barPlot.barWidth = 0.75f;
    barPlot.barCornerRadius = 0.0;
    barPlot.dataSource = self;
	barPlot.delegate = self;
	barPlot.fill = [CPFill fillWithColor:[CPColor colorWithComponentRed:73./255.0 green:108./255.0 blue:202./255.0 alpha:0.5]];
    
    CPMutableLineStyle *barLineStyle = [CPMutableLineStyle lineStyle];
	barLineStyle.lineColor = [CPColor colorWithComponentRed:212./255 green:175./255 blue:108./255 alpha:1.0];
    barLineStyle.lineWidth = 1.0;
    
    barPlot.lineStyle = barLineStyle;

    [histogramGraph addPlot:barPlot toPlotSpace:plotSpace];
}

-(void)setPaddingForGraph:(CPXYGraph *)graph {
//Implemented in subclass
}

-(void)setGraphIntervals {
    NSTimeInterval dateRange = [labTestGraphContainer dateRange];
    
    if (yUnit == 0) {
        yUnit = labTestGraphContainer.labResultsMinValue;
    }
    
    [refDate release];
    refDate = [[NSDate dateWithTimeInterval:-dateRange sinceDate:labTestGraphContainer.currentDate] retain];
    
    CPXYPlotSpace *plotSpace = (CPXYPlotSpace *)scatterPlotGraph.defaultPlotSpace;
    plotSpace.allowsUserInteraction = NO;
    
    plotSpace.yRange = [CPPlotRange plotRangeWithLocation:CPDecimalFromFloat(labTestGraphContainer.absoluteMinValue-yUnit) length:CPDecimalFromFloat([labTestGraphContainer valueRange] + 2*yUnit)];
    plotSpace.xRange = [CPPlotRange plotRangeWithLocation:CPDecimalFromFloat(0) length:CPDecimalFromFloat(dateRange)];		
    
    
    self.dateFormatter.dateStyle = kCFDateFormatterShortStyle;

    //switch in subclass
    
}

-(void)setGraphAxes {

	CPXYAxisSet *axisSet = (CPXYAxisSet *)scatterPlotGraph.axisSet;
	CPXYAxis *xaxis = axisSet.xAxis;
	
	CPMutableTextStyle *textStyleXAxis = [CPMutableTextStyle textStyle];
	textStyleXAxis.fontName = @"Arial";
	textStyleXAxis.fontSize = 11.f;
	textStyleXAxis.color = [CPColor whiteColor];
	xaxis.labelTextStyle = textStyleXAxis;
    
    CPMutableLineStyle *lineStyle = [CPLineStyle lineStyle]; 
    lineStyle.lineColor = [CPColor colorWithComponentRed:1.0 green:1.0 blue:1.0 alpha:0.1];
    lineStyle.lineWidth = 1.0; 
    
	xaxis.axisLineStyle = nil;
	
    xaxis.isFloatingAxis = YES;
    
    xaxis.majorGridLineStyle = lineStyle;
    
	xaxis.majorTickLineStyle = nil;
	xaxis.majorIntervalLength = CPDecimalFromFloat(self.xUnit);
	xaxis.orthogonalCoordinateDecimal = CPDecimalFromFloat(labTestGraphContainer.absoluteMinValue - self.yUnit);
	xaxis.minorTicksPerInterval = 0;
	CPTimeFormatter *timeFormatter = [[[CPTimeFormatter alloc] initWithDateFormatter:self.dateFormatter] autorelease];
	timeFormatter.referenceDate = refDate;
	xaxis.labelFormatter = timeFormatter;
	
    
	CPXYAxis *yaxis = axisSet.yAxis;
    NSNumberFormatter *yFormatter = [[NSNumberFormatter alloc] init];
    [yFormatter setNumberStyle:NSNumberFormatterDecimalStyle];
    
    
    axisSet.yAxis.labelFormatter = yFormatter;
	CPMutableTextStyle *textStyleYAxis = [CPMutableTextStyle textStyle];;
	textStyleYAxis.fontName = @"Arial";
	textStyleYAxis.fontSize = 11.f;
	textStyleYAxis.color = [CPColor whiteColor];
	yaxis.labelTextStyle = textStyleYAxis;
	
	yaxis.axisLineStyle = nil;
	
	yaxis.majorTickLineStyle = nil;
    
    yaxis.isFloatingAxis = YES;
    
    yaxis.majorGridLineStyle = lineStyle;
    
	yaxis.majorIntervalLength =  CPDecimalFromFloat(self.yUnit);
    yaxis.minorTicksPerInterval = 0;
	yaxis.orthogonalCoordinateDecimal = CPDecimalFromFloat(0);
    
}

-(NSDateFormatter *)dateFormatter {

    if (dateFormatter) {
        return dateFormatter;
    }
    dateFormatter = [[NSDateFormatter alloc] init];
    return dateFormatter;
}

-(void)setReferenceRanges {
    
    CPColor *RefColor = [CPColor colorWithComponentRed:166./255 green:124./255 blue:78./255 alpha:1.0];
	
    LabTest *labTest = [UserSession selectedLabTest];
	
    CPScatterPlot *dataSourceLinePlot = [[[CPScatterPlot alloc] init] autorelease];
	dataSourceLinePlot.identifier = @"labResult";
    
    CPMutableLineStyle *lineStyle = [[dataSourceLinePlot.dataLineStyle mutableCopy] autorelease];
   
    ///////////////////////Reference High Line	
	if ([[labTest mostRecentLabResult] referenceHigh]) {
		
		CPScatterPlot *refHighLinePlot = [[[CPScatterPlot alloc] init] autorelease];
		refHighLinePlot.identifier = @"refHigh";
        
		lineStyle = [[refHighLinePlot.dataLineStyle mutableCopy] autorelease];
		lineStyle.lineWidth = 2.f;
		lineStyle.dashPattern = [NSArray arrayWithObjects:[NSNumber numberWithInt:4], [NSNumber numberWithInt:4], nil];
		lineStyle.lineColor = RefColor;
		refHighLinePlot.dataLineStyle = lineStyle;
		
		refHighLinePlot.dataSource = self;
        
        
        CPImage *shadingImage = [CPImage imageForPNGFile:[[NSBundle bundleForClass:[self class]] pathForResource:@"LabMain-iPad-bg-grid-shaded-area" ofType:@"png"]];
        shadingImage.tiled = YES;
        CPFill *areaFill = [CPFill fillWithImage:shadingImage];
        
        
        refHighLinePlot.areaFill = areaFill;
        refHighLinePlot.areaBaseValue = CPDecimalFromFloat([labTestGraphContainer referenceRangeMaxOfLowRange]);
        
		[scatterPlotGraph addPlot:refHighLinePlot];
	}
	///////////////////////Reference High Line
	
	///////////////////////Reference Low Line
	if ([[labTest mostRecentLabResult] referenceLow]) {
        
		CPScatterPlot *refLowLinePlot = [[[CPScatterPlot alloc] init] autorelease];
		refLowLinePlot.identifier = @"refLow";
		
		lineStyle = [[refLowLinePlot.dataLineStyle mutableCopy] autorelease];
		lineStyle.lineWidth = 2.f;
		lineStyle.dashPattern = [NSArray arrayWithObjects:[NSNumber numberWithInt:4], [NSNumber numberWithInt:4], nil];
		lineStyle.lineColor = RefColor;
		refLowLinePlot.dataLineStyle = lineStyle;
		
		refLowLinePlot.dataSource = self;
        
        
        CPImage *shadingImage = [CPImage imageForPNGFile:[[NSBundle bundleForClass:[self class]] pathForResource:@"LabMain-iPad-bg-grid-shaded-area" ofType:@"png"]];
        shadingImage.tiled = YES;
        CPFill *areaFill = [CPFill fillWithImage:shadingImage];
        refLowLinePlot.areaFill2 = areaFill;
        refLowLinePlot.areaBaseValue2 = CPDecimalFromFloat([labTestGraphContainer referenceRangeMaxOfLowRange]);
		[scatterPlotGraph addPlot:refLowLinePlot];
	}
	///////////////////////Reference Low Line
    
    lineStyle.dashPattern = nil;
	lineStyle.lineWidth = 3.f;
	lineStyle.lineColor = [CPColor colorWithComponentRed:122./255 green:154./255 blue:246./255 alpha:1.0];
	dataSourceLinePlot.dataLineStyle = lineStyle;
    
	CPPlotSymbol *plotSymbol = [CPPlotSymbol ellipsePlotSymbol];
	plotSymbol.fill = [CPFill fillWithColor:[CPColor colorWithComponentRed:122./255 green:154./255 blue:246./255 alpha:1.0]];
	lineStyle.lineColor = [CPColor colorWithComponentRed:122./255 green:154./255 blue:246./255 alpha:1.0];
	plotSymbol.lineStyle = lineStyle;
	plotSymbol.size = CGSizeMake(1,1);
	dataSourceLinePlot.plotSymbol = plotSymbol;	
	dataSourceLinePlot.dataSource = self;
    
	[scatterPlotGraph addPlot:dataSourceLinePlot];
}

-(CGFloat)getBufferForValue:(CGFloat)value {
    
    CGFloat scale = 0.1;
    return scale*value;
}


-(BOOL)plotSpace:(CPPlotSpace *)space shouldScaleBy:(CGFloat)interactionScale aboutPoint:(CGPoint)interactionPoint {
    [self clearPlotAnnotations];    
       
    if ([labTestGraphContainer numberOfLabResults] > 0) {
        if (histogramGHV.hidden) {
            return YES;
        }
    }
    
    return NO;   
}

-(void)clearPlotAnnotations {
    
    CPScatterPlot *plot = (CPScatterPlot *)[scatterPlotGraph plotWithIdentifier:@"labResult"]; 
    [plot removeAllAnnotations];
    [scatterPlotGHV.hostedGraph removeAllAnnotations];
    
    dateLabel.text = @"";
}

-(void)addPointSymbolToPlot:(CPPlot *)plot withAnchorPointArray:(NSArray *)anchorPointArray {
      
    
    CPPlotSpaceAnnotation *symbolAnnotation = [[CPPlotSpaceAnnotation alloc] initWithPlotSpace:plot.plotSpace anchorPlotPoint:anchorPointArray]; 
    [symbolAnnotation setDisplacement:CGPointMake(3., -2.)];

    
    CPBorderedLayer *symbolHostLayer = [[CPBorderedLayer alloc] initWithFrame:CGRectMake(0,0, 25, 26)]; 
    
    symbolHostLayer.fill = [CPFill fillWithImage:[CPImage imageForPNGFile:[[NSBundle bundleForClass:[self class]] pathForResource:@"LabMain_iPad-icn-gridpoint" ofType:@"png"]]]; 
    
    symbolAnnotation.contentLayer = symbolHostLayer; 
    symbolAnnotation.annotationHostLayer = plot; 
    [symbolAnnotation positionContentLayer]; 
    
    [symbolAnnotation.annotationHostLayer addAnnotation:symbolAnnotation]; 

    [symbolAnnotation release];
}

-(void)addLineAnnotationToPlot:(CPPlot *)plot withAnchorPointArray:(NSArray *)anchorPointArray withIndex:(NSUInteger)index{
    
    const static CGFloat AnnotationHeight = 1000.0;
    const static CGFloat AnnotationWidth  = 2.0;
 //   const static CGFloat LineWidth = 0.5;
    
    const static CGFloat AnnotationColorComponentRed = 255./255;
    const static CGFloat AnnotationColorComponentGreen = 228./255;
    const static CGFloat AnnotationColorComponentBlue = 152./255;

    
    CPPlotSpaceAnnotation *annotation = [[CPPlotSpaceAnnotation alloc] initWithPlotSpace:plot.plotSpace anchorPlotPoint:anchorPointArray]; 
    
    CPBorderedLayer *hostLayer = [[CPBorderedLayer alloc] initWithFrame:CGRectMake(0,0, AnnotationWidth, AnnotationHeight)]; 
      
    
    hostLayer.fill = [CPFill fillWithColor:[CPColor colorWithComponentRed:AnnotationColorComponentRed green:AnnotationColorComponentGreen blue:AnnotationColorComponentBlue alpha:1.0]]; 
    
    annotation.contentLayer = hostLayer; 
    annotation.contentLayer.shadowColor = [UIColor colorWithRawValuesForRed:50 green:96 blue:210 alpha:1.0].CGColor;
    annotation.contentLayer.shadowOffset = CGSizeMake(1.0, 0.0);
    annotation.contentLayer.shadowOpacity = 0.7;
    
    annotation.annotationHostLayer = plot; 
    [annotation positionContentLayer]; 
    [annotation.annotationHostLayer addAnnotation:annotation]; 
    
    [annotation release];
}

-(void)updateDateLabelWithLabResult:(LabResult *)labResult {
    
    NSDate *labResultDate  = [labResult resultedDate];
    NSDateFormatter *dateLabelFormatter = [[NSDateFormatter alloc] init];
    [dateLabelFormatter setDateFormat:@"hh:mma MM/dd/YY"];
    NSString *labResultDateString = [dateLabelFormatter stringFromDate:labResultDate];
    
    
    dateLabel.text = labResultDateString;

    [dateLabelFormatter release];

    dateLabel.hidden = NO;
}

//Implemented in subclass
-(CGFloat)getLayerWidth {
    return 0;
}

//Implemented in subclass
-(CGFloat)getLayerHeight {
    return 0;
}

//Implemented in subclass
-(CGFloat)getTextFontSize {
    return 0;
}

-(void)addTextAnnotationsToPlot:(CPPlot *)plot atIndex:(NSUInteger)index withAnchorPointArray:(NSArray *)anchorPointArray {
    
    CGFloat textConstraintWidth =  [self getLayerWidth];
    CGFloat textConstraintHeight = [self getLayerHeight];
    CGFloat textFontSize = [self getTextFontSize];
    
    
    CPMutableTextStyle *textStyle = [CPMutableTextStyle textStyle];
    textStyle.color = [CPColor colorWithComponentRed:247./255 green:241./255 blue:194./255 alpha:1.0];
    textStyle.fontSize = textFontSize;
    textStyle.fontName = @"Arial-BoldMT";
    
    LabResult *labResult = [labTestGraphContainer labResultAtIndex:index];
    
    
    NSString *labResultValue = [labResult value];
    NSString *labResultUnits = [labResult valueUnits];
    NSString *fullTextString = [NSString stringWithFormat:@"%@ %@",labResultValue, labResultUnits];
    
    
    CGSize labResultValueSize = [fullTextString sizeWithFont:[UIFont fontWithName:textStyle.fontName size:textStyle.fontSize] constrainedToSize:CGSizeMake(textConstraintWidth, textConstraintHeight)];

    
    CPTextLayer *valueTextLayer = [[[CPTextLayer alloc] initWithText:fullTextString style:textStyle] autorelease];
    
    valueTextLayer.shadowColor = [UIColor blackColor].CGColor;
    valueTextLayer.shadowOffset = CGSizeMake(0.0, -1.0);
    valueTextLayer.shadowOpacity = 1.0;
    
    valueTextLayer.backgroundColor = [UIColor clearColor].CGColor;
    
    valueTextLayer.frame = CGRectMake(0, 0, labResultValueSize.width, textConstraintHeight);
    
    
    CGFloat imageLayerWidth = labResultValueSize.width + 20.0;
    
    
    CGPoint textLayerPoint = CGPointMake(imageLayerWidth/2.0, 0);
    NSDecimal *decimalPoint = malloc(sizeof(NSDecimal) * 2);
    textLayerPoint = [plot.graph convertPoint:textLayerPoint toLayer:scatterPlotGHV.hostedGraph];
    
    [plot.plotSpace plotPoint:decimalPoint forPlotAreaViewPoint:textLayerPoint];
    CGPoint maxPoint = CGPointMake([self getGraphWidth], 0.0);
    NSDecimal *decimalMaxPoint = malloc(sizeof(NSDecimal) * 2);
    maxPoint = [plot.graph convertPoint:maxPoint toLayer:scatterPlotGHV.hostedGraph];
    
    [plot.plotSpace plotPoint:decimalMaxPoint forPlotAreaViewPoint:maxPoint];
    
    NSDecimal decimalPointX = decimalPoint[0];
    NSDecimal decimalPointMax = decimalMaxPoint[0];
    
    NSDecimalNumber *decimalNumberX = [NSDecimalNumber decimalNumberWithDecimal:decimalPointX];
    NSDecimalNumber *decimalNumberMax = [NSDecimalNumber decimalNumberWithDecimal:decimalPointMax];
    
    
    if ([decimalNumberX intValue] > [[anchorPointArray objectAtIndex:0] intValue]) {

        anchorPointArray = [NSArray arrayWithObjects:decimalNumberX, [anchorPointArray objectAtIndex:1], nil];
        
    } else if ([decimalNumberX intValue] + [[anchorPointArray objectAtIndex:0] intValue] > [decimalNumberMax intValue]) {
        NSDecimalNumber *num = [decimalNumberMax decimalNumberBySubtracting:decimalNumberX];
      
        anchorPointArray = [NSArray arrayWithObjects:num, [anchorPointArray objectAtIndex:1], nil];

    }
    
    CPPlotSpaceAnnotation *valueAnnotation = [[CPPlotSpaceAnnotation alloc] initWithPlotSpace:plot.plotSpace anchorPlotPoint:anchorPointArray];
    
    CPBorderedLayer *layer = [[CPBorderedLayer alloc] initWithFrame:CGRectMake(0, 0, imageLayerWidth, textConstraintHeight)];
    [layer setPaddingLeft:10];
    [layer setPaddingTop:(textConstraintHeight-labResultValueSize.height)/2.0];
    
    [layer setFill:[CPFill fillWithImage:[CPImage imageForPNGFile:[[NSBundle bundleForClass:[self class]] pathForResource:@"LabMain_iPad-btn-bg-for-number-label" ofType:@"png"]]]];
                  
    [layer addSublayer:valueTextLayer];
    
    valueAnnotation.contentLayer = layer;
    
    
    [self updateDateLabelWithLabResult:labResult];
    
    
    [scatterPlotGHV.hostedGraph addAnnotation:valueAnnotation];
    
    [valueAnnotation release];
}

-(void)drawVerticalSelectionLineInSpace:(CPPlotSpace *)space withEvent:(id)event atPoint:(CGPoint)point  {
//Implemented in subclasses

}

-(BOOL)plotSpace:(CPPlotSpace *)space shouldHandlePointingDeviceDownEvent:(id)event atPoint:(CGPoint)point { 
    CPScatterPlot *plot = (CPScatterPlot *)[scatterPlotGraph plotWithIdentifier:@"labResult"]; 

    BOOL response = YES;
    
	if ([labTestGraphContainer numberOfLabResults] > 0) {
        if (histogramGHV.hidden) {
            if ([plot indexOfVisiblePointClosestToPlotAreaPoint:point] != NSNotFound) {
                [self drawVerticalSelectionLineInSpace:space withEvent:event atPoint:point];    
            } else {
                response = NO;
            }
        }
    }
    return response; 
}    

-(BOOL)plotSpace:(CPPlotSpace *)space shouldHandlePointingDeviceDraggedEvent:(id)event atPoint:(CGPoint)point {
    CPScatterPlot *plot = (CPScatterPlot *)[scatterPlotGraph plotWithIdentifier:@"labResult"]; 
    
    BOOL response = YES;
    

    if ([labTestGraphContainer numberOfLabResults] > 0) {
        if (histogramGHV.hidden) {
             if ([plot indexOfVisiblePointClosestToPlotAreaPoint:point] != NSNotFound) {
                 [self drawVerticalSelectionLineInSpace:space withEvent:event atPoint:point];
             } else {
                 response = NO;
             }
        }
    }
    
    return response;
}

-(void)constructScatterPlot {
	
	noLabsL.hidden = YES;
    
    
	scatterPlotGraph = [[CPXYGraph alloc] initWithFrame:CGRectZero];
	scatterPlotGHV.backgroundColor = [UIColor clearColor];
	scatterPlotGHV.hostedGraph = scatterPlotGraph;
	histogramGraph.plotAreaFrame.masksToBorder = NO;

    [self setPaddingForGraph:scatterPlotGraph];
    
    scatterPlotGraph.defaultPlotSpace.delegate = self;
    
    self.yUnit = [self getBufferForValue:[labTestGraphContainer valueRange]];
    self.xUnit = 0;
    
   	[self setGraphIntervals];
    
    [self setGraphAxes];
    
    [self setReferenceRanges];
    
	
	if ([labTestGraphContainer numberOfLabResults] > 0) {
		noLabsL.hidden = YES;
	}
	else {
		noLabsL.hidden = NO;
	}
}

-(void)refresh {
    [self clearPlotAnnotations];
  	[labTestGraphContainer refreshWithPatient:[UserSession selectedPatient] labTest:[UserSession selectedLabTest]];
}

-(void)clearGraphs {
	
	[self clearScatterPlotGraph];
	[self clearHistogramGraph];
}

-(void)clearScatterPlotGraph {

	scatterPlotGHV.hostedGraph = nil;
	[scatterPlotGraph release], scatterPlotGraph = nil;
}

-(void)clearHistogramGraph {
	
	histogramGHV.hostedGraph = nil;
	[histogramGraph release], histogramGraph = nil;
}

-(void)reloadHistogramGraph {
	
	//Implemented in subclass
	
	[self clearHistogramGraph];
	
	[self constructHistogram];
}

-(void)reloadScatterPlotGraph {

	[self clearScatterPlotGraph];
	
	[self constructScatterPlot];
}

-(void)reloadGraphs {
	
	[self reloadScatterPlotGraph];
	[self reloadHistogramGraph];
}


-(void)showRange:(LabMainContainerRange)range sender:(id)sender {
	
	((UIButton *)sender).selected = YES;
	labTestGraphContainer.currentRange = range;
	
	NSString *rangeString = [LabMainContainer stringFromRange:range];
	NSDictionary *tagDict = [NSDictionary dictionaryWithObjectsAndKeys:rangeString, @"dateSelection", nil];
	[MetricsPusher reportMetricsWithUserEventValue:@"SelectDateRangeOnLabViewer" tagDictionary:tagDict];
	
	[self reloadGraphs];
    [self checkMedications];
	
}

-(IBAction)showDayRange:(id)sender {
	[self showRange:LabTestRangeDay sender:sender];
}

-(IBAction)showWeekRange:(id)sender {
	[self showRange:LabTestRangeWeek sender:sender];
}

-(IBAction)showMonthRange:(id)sender {
	[self showRange:LabTestRangeMonth sender:sender];
}

-(IBAction)showYearRange:(id)sender {
	[self showRange:LabTestRangeYear sender:sender];
}

-(IBAction)showTwoYearRange:(id)sender {
	[self showRange:LabTestRangeTwoYear sender:sender];
}

-(IBAction)showAllRange:(id)sender {
	[self showRange:LabTestRangeAll sender:sender];
}


-(void)checkMedications {

    if ([inpatientB isSelected] || ![noMedicationsL isHidden]) {
        [self checkInpatientMedications];
    }
    if ([outpatientB isSelected] || ![noMedicationsL isHidden]) {
        
        [self checkInpatientMedications];
    }
}

-(IBAction)showOutpatientHistogram:(id)sender {
    
    [self clearPlotAnnotations];
    
    labTestGraphContainer.currentMedicationSource = MedicationSourceOutpatient;
    
    inpatientB.selected = NO;
    
    
	if (![outpatientB isSelected]) {
        
		[MetricsPusher reportMetricsWithUserEventValue:@"ShowOutpatientMedicationsOnLabViewer" tagDictionary:nil];
		
        if ([labTestGraphContainer numberOfMedications] == 0) {
            
            noMedicationsL.text = @"No Outpatient medications in this range of lab tests";
            noMedicationsL.hidden = NO;			
            histogramGHV.hidden = YES;
            histogramSV.hidden = YES;
            
            outpatientB.selected = YES;
            
        } else {
            
            [self reloadHistogramGraph];
            
            noMedicationsL.hidden = YES;
            histogramGHV.hidden = NO;
            histogramSV.hidden = NO;
            
            outpatientB.selected = YES;
        }
        
		
	} else {
		
		histogramGHV.hidden = YES;
        histogramSV.hidden = YES;
        
		noMedicationsL.hidden = YES;
        
		outpatientB.selected = NO;
	}
}

-(void)checkOutpatientMedications {

    if ([labTestGraphContainer numberOfMedications] == 0) {
        
        noMedicationsL.text = @"No Outpatient medications in this range of lab tests";
        noMedicationsL.hidden = NO;			
        histogramGHV.hidden = YES;
        histogramSV.hidden = YES;
        
    } else {
        
        noMedicationsL.hidden = YES;
        histogramGHV.hidden = NO;
        histogramSV.hidden = NO;
        
    }
}

-(IBAction)showInpatientHistogram:(id)sender {
    
    [self clearPlotAnnotations];
    
	labTestGraphContainer.currentMedicationSource = MedicationSourceInpatient;
	outpatientB.selected = NO;
    
	if (![inpatientB isSelected]) {
    
		[MetricsPusher reportMetricsWithUserEventValue:@"ShowInpatientMedicationsOnLabViewer" tagDictionary:nil];
		
        if ([labTestGraphContainer numberOfMedications] == 0) {
            
            noMedicationsL.text = @"No Inpatient medications in this range of lab tests";
            noMedicationsL.hidden = NO;
            histogramGHV.hidden = YES;
            histogramSV.hidden = YES;
            
            inpatientB.selected = YES;
            
        } else {
            
            [self reloadHistogramGraph];
            
            noMedicationsL.hidden = YES;
            histogramGHV.hidden = NO;
            histogramSV.hidden = NO;
            
            inpatientB.selected = YES;
            
        }   
		
		
	} else {
		
		histogramGHV.hidden = YES;
        histogramSV.hidden = YES;

		noMedicationsL.hidden = YES;
		
		inpatientB.selected = NO;
	}
}

-(void)checkInpatientMedications {
    if ([labTestGraphContainer numberOfMedications] == 0) {
        
        noMedicationsL.text = @"No Inpatient medications in this range of lab tests";
        noMedicationsL.hidden = NO;
        histogramGHV.hidden = YES;
        histogramSV.hidden = YES;
        
    } else {
                    
        noMedicationsL.hidden = YES;
        histogramGHV.hidden = NO;
        histogramSV.hidden = NO;
        
    }
}

-(void)showLabTest:(LabTest *)theLabTest {

	labTestNameL.text = [theLabTest testname];
	
	histogramGHV.hidden = YES;
    histogramSV.hidden = YES;

	scatterPlotGHV.hidden = NO;
	noMedicationsL.hidden = YES;

	labTestNameL.hidden = NO;
	dayB.hidden = NO;
	weekB.hidden = NO;
	monthB.hidden = NO;
	yearB.hidden = NO;
	twoYearB.hidden = NO;
	allB.hidden = NO;
	inpatientB.hidden = NO;
	outpatientB.hidden = NO;
	
	inpatientB.selected = NO;
	outpatientB.selected = NO;	

	labTestGraphContainer.currentRange = LabTestRangeTwoYear;
 	[self refresh];
}


#pragma mark - Initialization
-(void)hideGraphs {
	histogramGHV.hidden = YES;
    histogramSV.hidden = YES;

	scatterPlotGHV.hidden = YES;
	labTestNameL.hidden = YES;
	dayB.hidden = YES;
	weekB.hidden = YES;
	monthB.hidden = YES;
	yearB.hidden = YES;
	twoYearB.hidden = YES;
	allB.hidden = YES;
	inpatientB.hidden = YES;
	outpatientB.hidden = YES;
	noMedicationsL.hidden = YES;
	noLabsL.hidden = YES;
}

-(void)processDidChangePatient:(NSNotification *)notification {
    //implemented in subclass
	shouldRefresh = YES;
    labResultTV.hidden = YES;
}

-(void)processWillChangeLabTest:(NSNotification *)notification {
    //implemented in subclass    
}

-(void)processDidChangeLabResult:(NSNotification *)notification {
    labResultTV.hidden = NO;
    LabResult *currentLabResult = [UserSession selectedLabResult];
    labResultTV.text = [currentLabResult valueForKey:LabResultValueKey];
}

-(void)processDidChangeLabTest:(NSNotification *)notification {
    //implemented in subclass    
    labResultTV.hidden = YES;

}

-(void)processDidShowChemTest:(NSNotification *)notification {
    labResultTV.hidden = YES;
}

-(void)processDidShowMicroResult:(NSNotification *)notification {
    labResultTV.hidden = NO;   
}

-(void)registerForNotifications {
	
	NSNotificationCenter *defaultCenter = [NSNotificationCenter defaultCenter];

	[defaultCenter addObserver:self selector:@selector(processWillChangeLabTest:) name:UserSessionWillChangeLabTest object:nil];
	
	[defaultCenter addObserver:self selector:@selector(processDidChangeLabTest:) name:UserSessionDidChangeLabTest object:nil];

	[defaultCenter addObserver:self selector:@selector(processDidChangePatient:) name:UserSessionDidChangePatient object:nil];
    
    [defaultCenter addObserver:self selector:@selector(processDidChangeLabResult:) name:UserSessionDidChangeLabResult object:nil];
    
    [defaultCenter addObserver:self selector:@selector(processDidShowChemTest:) name:UserSessionShowChemTest object:nil];
    
    [defaultCenter addObserver:self selector:@selector(processDidShowMicroResult:) name:UserSessionShowMicroResults object:nil];
    
}

-(id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
	
	self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
	
	if (self) {

		[self registerForNotifications];
		
		labTestGraphContainer = [[LabMainContainer alloc] initWithDelegate:self];
		
		self.title = @"Lab Viewer";
		shouldRefresh = YES;
	}
	
	return self;
}


#pragma mark - LabGraphContainerDelegate Methods
-(void)labTestGraphContainerDidChangeCurrentRange:(LabMainContainer *)container {
	
	dayB.selected=weekB.selected=monthB.selected=yearB.selected=twoYearB.selected=allB.selected=NO;
	dayB.backgroundColor=weekB.backgroundColor=monthB.backgroundColor=yearB.backgroundColor=twoYearB.backgroundColor=allB.backgroundColor=[UIColor clearColor];
	
	switch (container.currentRange) {
		case LabTestRangeDay:
			dayB.selected = YES;
			break;
		case LabTestRangeWeek:
			weekB.selected = YES;
			break;
		case LabTestRangeMonth:
			monthB.selected = YES;
			break;
		case LabTestRangeYear:
			yearB.selected = YES;
			break;
		case LabTestRangeTwoYear:
			twoYearB.selected = YES;
			break;			
		default:
			allB.selected = YES;
			break;
	}
}

-(void)labTestGraphContainerHasLoadedLabResults:(LabMainContainer *)container {
	[self reloadGraphs];
}

-(void)labTestGraphContainerHasLoadedAllMedications:(LabMainContainer *)container {
	[self reloadHistogramGraph];
}


#pragma mark - Memory Management
-(void)unregisterFromNotifications {
	[[NSNotificationCenter defaultCenter] removeObserver:self];
}

-(void)dealloc {

	[self unregisterFromNotifications];
	
	[dataForHistogram release], dataForHistogram = nil;
	[dataForScatterPlot release], dataForScatterPlot = nil;
	[histogramGraph release], histogramGraph = nil;
	
	labTestGraphContainer.delegate = nil;
	[labTestGraphContainer release], labTestGraphContainer = nil;
	[refDate release], refDate = nil;
	[scatterPlotGraph release], scatterPlotGraph = nil;
	
	[super dealloc];
}


#pragma mark - Orientation
-(BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    return UIInterfaceOrientationIsLandscape(interfaceOrientation);
}


#pragma mark - View Lifecycle

-(void)viewWillAppear:(BOOL)animated {
    [self clearPlotAnnotations];
    
    if (shouldRefresh) {
		[self hideGraphs];
		shouldRefresh = NO;
	}
}

-(void)viewDidLoad {
	[super viewDidLoad];
	
	noLabsL.hidden = YES;
	noMedicationsL.hidden = YES;
	
	graphBackgroundV.layer.borderColor = [UIColor colorWithRawValuesForRed:240 green:198 blue:122 alpha:1.0].CGColor;
	graphBackgroundV.layer.borderWidth = 3.f;
	graphBackgroundV.layer.cornerRadius = 5.f;
}

-(void)viewDidUnload {
	
	[allB release], allB = nil;
	[dayB release], dayB = nil;
	[histogramGHV release], histogramGHV = nil;
	[histogramSV release], histogramSV = nil;
	[inpatientB release], inpatientB = nil;
	[labTestNameL release], labTestNameL = nil;
	[monthB release], monthB = nil;
	[noLabsL release], noLabsL = nil;
	[noMedicationsL release], noMedicationsL = nil;
	[outpatientB release], outpatientB = nil;
	[scatterPlotGHV release], scatterPlotGHV = nil;
	[twoYearB release], twoYearB = nil;
	[weekB release], weekB = nil;
	[yearB release], yearB = nil;
	
	[super viewDidUnload];
}

@end