#import "LabResultManager.h"
#import "LabMainContainerDelegate.h"
#import "MedicationManager.h"
#import "Parser.h"
#import "Resource.h"

#define oneDay 24*60*60

typedef enum {
	LabTestRangeDay = 0,
	LabTestRangeWeek = 1,
	LabTestRangeMonth = 2,
	LabTestRangeYear = 3,
	LabTestRangeTwoYear = 4,
	LabTestRangeAll = 5
} LabMainContainerRange;

typedef enum {
	MedicationSourceInpatient = 0,
	MedicationSourceOutpatient = 1
} MedicationSource;


@interface LabMainContainer : Resource <LabResultContainer, MedicationContainer> {
	
	LabResult *startResult;
	LabResult *endResult;
	
	NSMutableArray *filteredLabResults;
	NSArray *filteredMedications;
	NSMutableArray *labResults;
	NSMutableArray *medications;
    
}

//TODO: Move this to internal of class
@property (nonatomic, retain) NSDate *currentDate;

//TODO: Become readonly?
@property (nonatomic, retain) NSDate *earliestDate;
@property (nonatomic) CGFloat labResultsMaxValue;
@property (nonatomic) CGFloat labResultsMinValue;
@property (nonatomic) CGFloat referenceRangeMaxValue;
@property (nonatomic) CGFloat referenceRangeMinValue;
@property (nonatomic) CGFloat referenceRangeMinOfHighRange;
@property (nonatomic) CGFloat referenceRangeMaxOfLowRange;
@property (nonatomic) CGFloat absoluteMaxValue;
@property (nonatomic) CGFloat absoluteMinValue;


@property (nonatomic) BOOL labTestHasReferenceRangeHigh;
@property (nonatomic) BOOL labTestHasReferenceRangeLow;

@property (nonatomic) LabMainContainerRange currentRange;
@property (nonatomic) MedicationSource currentMedicationSource;
@property (nonatomic, assign) id<LabMainContainerDelegate> delegate;

@property (nonatomic) NSInteger totalNumberOfLabResults;
@property (nonatomic) NSInteger totalNumberOfMedications;

-(NSTimeInterval)dateRange;
-(id)initWithDelegate:(id<LabMainContainerDelegate>)theDelegate;
-(LabResult *)labResultAtIndex:(NSUInteger)index;
-(Medication *)medicationAtIndex:(NSUInteger)index;
-(NSInteger)numberOfLabResults;
-(NSInteger)numberOfMedications;
-(void)refreshWithPatient:(Patient *)thePatient labTest:(LabTest *)theLabTest;
-(CGFloat)valueRange;

+(NSString *)stringFromRange:(LabMainContainerRange)range;

@end 