//
//  LabTestPanelViewController.h
//  PatientViewer
//
//  Created by Grant Oladipo on 3/9/11.
//  xxxxxxxxx xxxx xxxxxxx xxx xxxxxx xxxxxxxxxxxxxxxxxxxxxx
//

#import "LabPanelContainerDelegate.h"

#define LabTestCellIdentifier		@"LabTest"
#define NoLabTestsCellIdentifier	@"NoResult"
#define MicroGroups                 @"allMicro"

typedef enum {
	ChemHem = 0,
	Microbiology = 1
} LabTab;

@class LabPanelContainer;

@interface LabPanel : UIViewController <LabPanelContainerDelegate, UITableViewDataSource, UITableViewDelegate> {
	
	LabPanelContainer *labPanelContainer;
    
	BOOL shouldRefresh;
    
    NSMutableArray *sectionInfoArray;
    NSMutableArray *microSectionInfoArray;
    
    BOOL areMicrosLoaded;

    NSMutableArray *microGroups;
//    NSIndexPath *selectedIndexPath;
}

@property (nonatomic, retain) NSIndexPath *selectedIndexPath;
@property (nonatomic, retain) IBOutlet UITableViewCell *customTVC;
@property (nonatomic, retain) IBOutlet UITableView *listTV;
@property (nonatomic, retain) IBOutlet UITableView *microTV;
@property (nonatomic, retain) IBOutlet UILabel *titleL;
@property (nonatomic, retain) IBOutlet UIButton *chemHemB;
@property (nonatomic, retain) IBOutlet UIButton *microbiologyB;
@property (nonatomic) LabTab currentTab;
@property (nonatomic, retain) IBOutlet UISegmentedControl *labTabSC;

@property (nonatomic, retain) NSMutableDictionary *microLabD;

-(IBAction)setCurrentLabTab:(UISegmentedControl *)sender;

-(void)configureCell:(UITableViewCell *)cell forIndexPath:(NSIndexPath *)indexPath identifier:(NSString *)cellIdentifier;
-(void)displayLabResultAtIndexPath:(NSIndexPath *)indexPath;
-(void)displayLabTestAtIndexPath:(NSIndexPath *)indexPath;

-(void)clearSectionHeaderCovers;

@end