//  LabPanelContainer.h
//	PatientViewer
//
//  Created by Grant Oladipo on 12/15/10.
//  xxxxxxxxx xxxx xxxxxxx xxx xxxxxx xxxxxxxxx


#import "LabTestGroupContainer.h"
#import "LabPanelContainerDelegate.h"
#import "Resource.h"
#import "LabResultContainer.h"
#import "LabResultGroup.h"

@class LabTest;
@class Patient;

@interface LabPanelContainer : Resource <LabTestGroupContainer, LabResultContainer> {
    NSMutableArray *labTestGroups;
	NSMutableArray *labTests;
    NSMutableArray *microLabResults;
    NSMutableArray *labResultsGroups;

}

@property (nonatomic, assign) id<LabPanelContainerDelegate> delegate;
@property (nonatomic) NSInteger totalNumberOfGroups;
@property (nonatomic) NSInteger totalNumberOfLabTests;
@property (nonatomic) NSInteger totalNumberOfMicroLabResults;
@property (nonatomic) NSInteger totalNumberOfLabResultsGroups;

-(BOOL)hasLabTestGroups;
-(BOOL)hasLabTests;
-(NSInteger)numberOfLabTestGroups;
-(NSInteger)numberOfLabTestsForGroupSection:(NSInteger)index;

-(LabTestGroup *)labTestGroupAtIndex:(NSInteger)index;
-(LabTest *)labTestAtIndex:(NSInteger)index inGroupSection:(NSInteger)sectionIndex;
-(void)removeAllObjects;
-(id)initWithDelegate:(id<LabPanelContainerDelegate>)theDelegate;


-(BOOL)hasLabResultGroups;
-(BOOL)hasMicroLabResults;
-(LabResultGroup *)labResultGroupAtIndex:(NSInteger)index;
-(NSInteger)numberofLabResultsForGroupSection:(NSInteger)index;
-(LabResult *)microLabResultAtIndex:(NSInteger)index inGroupSection:(NSInteger)sectionIndex;

-(void)refreshChemLabsWithPatient:(Patient *)patient;
-(void)refreshMicroLabsWithPatient:(Patient *)patient;
-(void)removeMicroObjects;
-(void)removeChemObjects;
@end