//
//  LabResultManager.m
//  PatientViewer
//
//  Created by Grant Oladipo on 12/15/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.

#import "LabTest.h"
#import "LabResult.h"
#import "LabResultManager.h"
#import "LabResultParser.h"
#import "Link.h"
#import "Patient.h"

@implementation LabResultManager


#pragma mark - Custom Accessors
-(void)labResultsForLabTest:(LabTest *)labTest result:(id<LabResultContainer>)theLabResultContainer {
	[labResultContainer release];
	labResultContainer = [theLabResultContainer retain];
	
	[self fetchResourceWithURL:[[[labTest links] objectForKey:LabTestLabResultsKey] href]];
}


#pragma mark - Custom Methods
-(LabResultParser *)parser {
	return [[[LabResultParser alloc] initWithDelegate:labResultContainer] autorelease];
}

#pragma mark - Initialization
+(id)labResultManager {
	
	LabResultManager *labResultManager = [[LabResultManager alloc] init];
	
	return [labResultManager autorelease];
}


#pragma mark - Memory Management
-(void)dealloc {
	
	[labResult release], labResult = nil;
	[labResultContainer release], labResultContainer = nil;
	[link release], link = nil;
	
	[super dealloc];
}

@end