//
//  LabResultParser.m
//  PatientViewer
//
//  Created by Grant Oladipo on 5/4/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//


#import "LabResult.h"
#import "LabResultParser.h"
#import "LabTest.h"
#import "Link.h"
#import "ManagerUtility.h"

@implementation LabResultParser

#pragma mark - Custom Actions
-(void)parseData:(NSData *)data {
	
	[xmlParser release];
	xmlParser = [[NSXMLParser alloc] initWithData:data];
	[xmlParser setDelegate:self];
	[xmlParser setShouldProcessNamespaces:YES];
	
	if (![xmlParser parse]) {
		NSLog(@"***Parsing UNSUCCESSFUL!");
		NSLog(@"Tried to parse:\n%@", [ManagerUtility prettyPrintXML:[[[NSString alloc] initWithData:data encoding:NSStringEncodingConversionAllowLossy] autorelease]]);
	}
}


#pragma mark - Initialization
-(id)initWithDelegate:(id)theDelegate {
	
	self = [super init];
	if (self) {
		delegate = [theDelegate retain];
	}
	
	return self;
}


#pragma mark - Memory Management
-(void)dealloc {
	
	[delegate release], delegate = nil;
	[xmlParser release], xmlParser = nil;
	
	[super dealloc];
}


#pragma mark -
#pragma mark NSXMLParserDelegate
-(void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName {
	
	if ([elementName isEqualToString:@"link"]) {
		[parentElement addLink:link];
	} else if ([elementName isEqualToString:@"labResult"]){
		
		parentElement = delegate;
		[delegate addLabResult:labResult];
		
	} else if ([elementName isEqualToString:@"labResults"]) {
	} 
}

-(void)parserDidEndDocument:(NSXMLParser *)parser {
	
	[delegate parserFinishedCreatingResource:self];
}

-(void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName attributes:(NSDictionary *)attributeDict {	
	
	if ([elementName isEqualToString:@"link"]) {
		
		[link release];
		link = [[Link alloc] initWithAttributeDictionary:attributeDict];
		
	} else if ([elementName isEqualToString:@"labResult"]) {
		
		[labResult release];
		labResult = [[LabResult alloc] initWithAttributeDictionary:attributeDict];
		parentElement = labResult;
		
	} else if ([elementName isEqualToString:@"labResults"]) {
		
		parentElement = delegate;
		[delegate setTotalNumberOfLabResults:[[attributeDict objectForKey:@"size"] integerValue]];
	}
}

@end
