//
//  LabTestGroupManager.m
//  PatientViewer
//
//  Created by Tea, Matt on 5/9/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "LabTestGroupManager.h"
#import "LabTestGroupParser.h"
#import "Link.h"
#import "Patient.h"

@implementation LabTestGroupManager

#pragma mark - Custom Accessors
-(void)labTestsWithGroupsForPatient:(Patient *)patient result:(id<LabTestGroupContainer>)theLabTestGroupContainer {
	[labTestGroupContainer release];
	labTestGroupContainer = [theLabTestGroupContainer retain];
	
	[self fetchResourceWithURL:[[[patient links] objectForKey:PatientLabTestGroupsLinkKey] href]];
}


#pragma mark - Custom Methods
-(LabTestGroupParser *)parser {
	return [[[LabTestGroupParser alloc] initWithDelegate:labTestGroupContainer] autorelease];
}


#pragma mark - Initialization
+(id)labTestGroupManager {
	
	LabTestGroupManager *labTestGroupManager = [[LabTestGroupManager alloc] init];
	
	return [labTestGroupManager autorelease];
}


#pragma mark - Memory Management
-(void)dealloc {
	
	[labTestGroupContainer release], labTestGroupContainer = nil;
	[xmlParser release], xmlParser = nil;
	
	[super dealloc];
}


@end