//
//  LabTestGroupParser.m
//  PatientViewer
//
//  Created by Tea, Matt on 5/6/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "LabResult.h"
#import "LabTest.h"
#import "LabTestGroup.h"
#import "LabTestGroupParser.h"
#import "LabTestGroupContainer.h"
#import "Link.h"
#import "ManagerUtility.h"


@implementation LabTestGroupParser



#pragma mark - Custom Actions
-(void)parseData:(NSData *)data {
	
	[xmlParser release];
	xmlParser = [[NSXMLParser alloc] initWithData:data];
	[xmlParser setDelegate:self];
	[xmlParser setShouldProcessNamespaces:YES];
	
	if (![xmlParser parse]) {
		NSLog(@"***Parsing UNSUCCESSFUL!");
		NSLog(@"Tried to parse:\n%@", [ManagerUtility prettyPrintXML:[[[NSString alloc] initWithData:data encoding:NSStringEncodingConversionAllowLossy] autorelease]]);
	}
}


#pragma mark - Initialization
-(id)initWithDelegate:(id)theDelegate {
	
	self = [super init];
	
	if (self) {
		delegate = [theDelegate retain];
	}
	
	return self;
}


#pragma mark - Memory Management
-(void)dealloc {
	
	[delegate release], delegate = nil;
	[xmlParser release], xmlParser = nil;
	
	[super dealloc];
}

#pragma mark - NSXMLParserDelegate
-(void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName {
	
	if ([elementName isEqualToString:@"link"]) {
		[parentElement addLink:link];
	} else if ([elementName isEqualToString:@"labResult"]) {
		
		parentElement = labTest;
		labTest.mostRecentLabResult = labResult;
		
	} else if ([elementName isEqualToString:@"labTest"]) {
		
		parentElement = delegate;
		[delegate addLabTest:labTest toGroup:labTestGroup];

		
	} else if ([elementName isEqualToString:@"labTestGroup"]) {
		
		parentElement = delegate;
        
		
	}else if ([elementName isEqualToString:@"labTestGroups"]) {
    }
}

-(void)parserDidEndDocument:(NSXMLParser *)parser {
	
	[delegate parserFinishedCreatingResource:self];
}

-(void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName attributes:(NSDictionary *)attributeDict {	
	
	if ([elementName isEqualToString:@"labTests"]) {
		
		parentElement = delegate;
		[delegate setTotalNumberOfGroups:[[attributeDict objectForKey:@"size"] integerValue]];
		
	} else if ([elementName isEqualToString:@"link"]) {
		
		[link release];
		link = [[Link alloc] initWithAttributeDictionary:attributeDict];
		
	} else if ([elementName isEqualToString:@"labTestGroup"]) {
		
		[labTestGroup release];
		labTestGroup = [[LabTestGroup alloc] initWithAttributeDictionary:attributeDict];
		parentElement = labTestGroup;
        
        [delegate addLabTestGroup:labTestGroup];

		
	} else if ([elementName isEqualToString:@"labTest"]) {
		
		[labTest release];
		labTest = [[LabTest alloc] initWithAttributeDictionary:attributeDict];
		parentElement = labTest;
        
	} else if ([elementName isEqualToString:@"labResult"]) {
		
		[labResult release];
		labResult = [[LabResult alloc] initWithAttributeDictionary:attributeDict];
		parentElement = labResult;
	}
}


@end
