//
//	LabManager.m
//
//  Created by Grant Oladipo on 12/15/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "LabTest.h"
#import "LabTestManager.h"
#import "LabTestParser.h"
#import "LabResult.h"
#import "Link.h"
#import "Patient.h"
#import "PatientMainContainer.h"

@implementation LabTestManager


#pragma mark - Custom Accessors
-(void)labTestsForPatient:(Patient *)patient result:(id<LabTestContainer>)theLabTestContainer {
	[labTestContainer release];
	labTestContainer = [theLabTestContainer retain];
	
	[self fetchResourceWithURL:[[[patient links] objectForKey:PatientLabTestsLinkKey] href]];
}


#pragma mark - Custom Methods
-(LabTestParser *)parser {
	return [[[LabTestParser alloc] initWithDelegate:labTestContainer] autorelease];
}


#pragma mark - Initialization
+(id)labTestManager {
	
	LabTestManager *labTestManager = [[LabTestManager alloc] init];
	
	return [labTestManager autorelease];
}


#pragma mark - Memory Management
-(void)dealloc {
	
	[labTestContainer release], labTestContainer = nil;
	[xmlParser release], xmlParser = nil;
	
	[super dealloc];
}


@end