//
//  untitled.m
//  PatientViewer
//
//  Created by Grant Oladipo on 3/2/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "ManagerUtility.h"

@implementation ManagerUtility


#pragma mark -
#pragma mark Custom Accessors
+(NSURL *)URLWithHostname:(NSString *)hostname resourcePath:(NSString *)resourcePath queryParameters:(NSDictionary *)queryParams {
	
	NSMutableString *urlString = [NSMutableString stringWithCapacity:1];
	[urlString appendFormat:@"%@/%@?", hostname, resourcePath];
	
	NSString *key;
	NSArray *allKeys = [queryParams allKeys];
	for (int i=0; i<[allKeys count]; i++) {
		
		key = [allKeys objectAtIndex:i];
		if (i>0) {
			[urlString appendString:@"&"];
		}
		[urlString appendFormat:@"%@=%@", key, [queryParams valueForKey:key]];
	}
	
	return [NSURL URLWithString:urlString];
}


#pragma mark -
#pragma mark Custom Actions
+(NSString *)prettyPrintXMLData:(NSData *)xmlData {
	return nil;
}

+(NSString *)prettyPrintXML:(NSString *)theXMLString {
	
	__block int numberOfSpace = 0;
	__block NSString *previousCharacter;
	__block NSString *newXMLString = [[NSString alloc] initWithString:@""];
	
	[theXMLString enumerateSubstringsInRange:NSMakeRange(0, [theXMLString length]) 
									 options:NSStringEnumerationByComposedCharacterSequences 
								  usingBlock:^(NSString *substring, NSRange substringRange, NSRange enclosingRange, BOOL *stop) {
									  
									  if ([substring isEqualToString:@">"] && ![previousCharacter isEqualToString:@"/"] && ![previousCharacter isEqualToString:@"?"]) {
										  numberOfSpace+=2;
									  }
									  
									  if ([substring isEqualToString:@"<"]) {
										  
										  newXMLString = [[[newXMLString autorelease] stringByAppendingString:@"\n"] retain];
										  
										  for (int i = 0; i<numberOfSpace; i++) {
											  newXMLString = [[[newXMLString autorelease] stringByAppendingString:@" "] retain];
										  }
									  }
									  
									  if ([substring isEqualToString:@"/"] && [previousCharacter isEqualToString:@"<"]) {
										  newXMLString = [[[newXMLString autorelease] substringToIndex:[newXMLString length]-3] retain];
										  newXMLString = [[[newXMLString autorelease] stringByAppendingString:@"<"] retain];
										  numberOfSpace-=4;
									  }
									  
									  newXMLString = [[[newXMLString autorelease] stringByAppendingString:substring] retain];
									  
									  [previousCharacter release];
									  previousCharacter = [substring retain];
								  }];
	
	return [newXMLString autorelease];
}

@end