//
//  MedicationMainContainer.m
//  PatientViewer
//
//  Created by Tea, Matt on 5/20/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "Medication.h"
#import "MedicationMainContainer.h"
#import "MedicationMainContainerDelegate.h"
#import "MedicationManager.h"
#import "UserSession.h"

@implementation MedicationMainContainer

@synthesize delegate;


#pragma mark - Custom Actions
-(void)refreshMedicationDetails {
    [[MedicationManager medicationManager] getDetailForMedication:[UserSession selectedMedication] result:self];
}

#pragma mark - Initialization
-(id)initWithDelegate:(id<MedicationMainContainerDelegate>)theDelegate {
	
	self = [super init];
	
	if (self) {
		delegate = theDelegate;
	}
	
	return self;
}

#pragma mark - ResourceContainer Methods
-(void)parserFinishedCreatingResource:(id<Parser>)parser {
	[delegate medicationMainContainerFinishedLoadingMedicationDetails:self];
}

#pragma mark - MedicationMainContainer Methods 
-(void)addMedication:(Medication*)theMedication {
    [delegate medicationMainContainerWillChangeMedicationDetails:self];
    
	[UserSession updateSelectedMedicationWithPropertyValue:[theMedication medicationDetail] forKey:MedicationDetailKey];
	
    [delegate medicationMainContainerDidChangeMedicationDetails:self];

}

@end
