//  MedicationManager.m
//  Patient Viewer
//
//  Created by Grant Oladipo on 12/15/10.
//  xxxxxxxxx xxxx xxxxxxx xxx xxxxxx xxxxxxxxxxxxxxxxxxxxxx

#import "Link.h"
#import "Medication.h"
#import "MedicationManager.h"
#import "MedicationParser.h"
#import "Patient.h"

@implementation MedicationManager


#pragma mark - Custom Accessors
-(MedicationParser *)parser {
	return [[[MedicationParser alloc] initWithDelegate:medicationContainer] autorelease];
}

-(void)activeMedicationsForPatient:(Patient *)patient result:(id<MedicationContainer>)theMedicationContainer {
	
	[medicationContainer release];
	medicationContainer = [theMedicationContainer retain];
	[self fetchResourceWithURL:[[[patient links] objectForKey:PatientMedicationLinkKey] href]];
}

-(void)outpatientMedicationsforPatient:(Patient *)patient result:(id<MedicationContainer>)theMedicationContainer {
	
	[medicationContainer release];
	medicationContainer = [theMedicationContainer retain];
	[self fetchResourceWithURL:[[[patient links] objectForKey:PatientOutpatientMedicationLinkKey] href]];
}

-(void)inpatientMedicationsforPatient:(Patient *)patient result:(id<MedicationContainer>)theMedicationContainer {
	
	[medicationContainer release];
	medicationContainer = [theMedicationContainer retain];
	[self fetchResourceWithURL:[[[patient links] objectForKey:PatientInpatientMedicationLinkKey] href]];
}

-(void)allMedicationsforPatient:(Patient *)patient result:(id<MedicationContainer>)theMedicationContainer {
	
	[medicationContainer release];
	medicationContainer = [theMedicationContainer retain];
	[self fetchResourceWithURL:[[[patient links] objectForKey:PatientAllMedicationLinkKey] href]];
}

-(void)getDetailForMedication:(Medication*)theMedication result:(id<MedicationContainer>)theMedicationContainer {
    [medicationContainer release];
    medicationContainer = [theMedicationContainer retain];
    [self fetchResourceWithURL:[[[theMedication links] objectForKey:MedicationDetailLinkKey] href]];
}


#pragma mark - Initialization
+(id)medicationManager {
	
	MedicationManager *medicationManager = [[MedicationManager alloc] init];
	
	return [medicationManager autorelease];
}


#pragma mark - Memory Management
-(void)dealloc {
	
	[link release], link = nil;
	[medication release], medication = nil;
	[medicationContainer release], medicationContainer = nil;
	
	[super dealloc];
}

@end
