//
//  MedicationPanel.h
//  PatientViewer
//
//  Created by Grant Oladipo on 4/28/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "Medication.h"
#import "MedicationPanelContainerDelegate.h"

typedef enum {
	inpatientIndexForInpatient = 0,
	nonVAIndexForInpatient = 1,
	outpatientIndexForInpatient = 2
} inpatientSectionOrder;

typedef enum {
    outpatientIndexForOutpatient = 0,
	nonVAIndexForOutpatient = 1,
	inpatientIndexForOutpatient = 2
} outpatientSectionOrder;


@interface MedicationPanel : UIViewController <MedicationPanelContainerDelegate> {
    

    
    NSUInteger numberOfSections;
    BOOL isInpatient;
    BOOL shouldRefresh;
    
    NSMutableArray *sectionInfoArray;
}

@property (nonatomic, retain) IBOutlet UITableView *listTV;

@property (nonatomic) NSUInteger numberOfInpatientMedications;
@property (nonatomic) NSUInteger numberOfOutpatientMedications;
@property (nonatomic) NSUInteger numberOfNonVAMedications;

@property (nonatomic) int inpatientIndex;
@property (nonatomic) int outpatientIndex;
@property (nonatomic) int nonVAIndex;
@property (nonatomic, retain) MedicationPanelContainer *medicationPanelContainer;

-(BOOL)isInpatient;
-(Medication*)getMedicationAtIndexPath:(NSIndexPath*)indexPath;
-(void)retrieveResults;
-(NSString *)titleForHeaderInSection:(NSInteger)section;
-(NSInteger)getNumberOfRowsForGroupInSection:(NSInteger)section;


@end