//
//  MedicationPanelContainer.h
//  PatientViewer
//
//  Created by Grant Oladipo on 4/27/11.
//  xxxxxxxxx xxxx xxxxxxx xxx xxxxxx xxxxxxxxx
//

#import "MedicationManager.h"
#import "MedicationPanelContainerDelegate.h"
#import "Resource.h"

@class Medication;

@interface MedicationPanelContainer : Resource <MedicationContainer> {
    
}

@property (nonatomic, assign) id<MedicationPanelContainerDelegate> delegate;
@property (nonatomic) NSInteger totalNumberOfMedications;
@property (nonatomic, retain) 	NSMutableArray *medications;
@property (nonatomic, retain) NSMutableArray *inpatientMedications;
@property (nonatomic, retain) NSMutableArray *outpatientMedications;
@property (nonatomic, retain) NSMutableArray *nonVAMedications;



-(BOOL)hasMedications;

-(NSInteger)numberOfMedications;
-(NSInteger)numberOfInpatientMedications;
-(NSInteger)numberOfOutpatientMedications;
-(NSInteger)numberOfNonVAMedications;

-(Medication *)medicationAtIndex:(NSInteger)index;
-(Medication *)inpatientMedicationAtIndex:(NSInteger)index;
-(Medication *)outpatientMedicationAtIndex:(NSInteger)index;
-(Medication *)nonVAMedicationAtIndex:(NSInteger)index;

-(void)clearMedicationLists;
-(void)refreshWithUserSession;
-(id)initWithDelegate:(id<MedicationPanelContainerDelegate>)theDelegate;

@end