//
//  MicroLabResultsManager.m
//  PatientViewer
//
//  Created by Tea, Matt on 10/4/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//
#import "MicroLabResultParser.h"
#import "MicroLabResultsManager.h"
#import "LabResult.h"
#import "Link.h"
#import "Patient.h"

@implementation MicroLabResultsManager


#pragma mark - Custom Accessors
-(void)microbiologyLabResultsForPatient:(Patient *)patient result:(id<LabResultContainer>)theLabResultContainer {
	[labResultContainer release];
	labResultContainer = [theLabResultContainer retain];
	
	[self fetchResourceWithURL:[[[patient links] objectForKey:PatientMicrobiologyLabResultsKey] href]];
}


#pragma mark - Custom Methods
-(MicroLabResultParser *)parser {
	return [[[MicroLabResultParser alloc] initWithDelegate:labResultContainer] autorelease];
}

#pragma mark - Initialization
+(id)microLabResultsManager {
	
	MicroLabResultsManager *microLabResultsManager = [[MicroLabResultsManager alloc] init];
	
	return [microLabResultsManager autorelease];
}


#pragma mark - Memory Management
-(void)dealloc {
	
	[labResult release], labResult = nil;
	[labResultContainer release], labResultContainer = nil;
	[link release], link = nil;
	
	[super dealloc];
}

@end