//  PatientMainViewController.m
//  PatientViewer
//
//  Created by Grant Oladipo on 1/25/11.
//  xxxxxxxxx xxxx xxxxxxx xxx xxxxxx xxxxxxxxxxxxxxxxxxxxxx

#import "Patient.h"
#import "PatientMainContainer.h"
#import "PatientMain.h"
#import "UserSession.h"

@implementation PatientMain

@synthesize patientMainContainer;


#pragma mark - Custom Actions
-(void)refresh {
	//Implemented by subclass
}

-(void)processDidChangePatient:(NSNotification *)notification {
	//Implemented by subclass
}

-(void)registerForNotifications {
	
	NSNotificationCenter *defaultCenter  = [NSNotificationCenter defaultCenter];
	
	[defaultCenter addObserver:self selector:@selector(processDidChangePatient:) name:UserSessionDidChangePatient object:nil];
}

-(void)unregisterFromNotifications {
	
	[[NSNotificationCenter defaultCenter] removeObserver:self];
}


#pragma mark - Initialization
-(id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {

	self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
	
	if (self) {
		
		[self registerForNotifications];
		
		patientMainContainer = [[PatientMainContainer alloc] initWithDelegate:self];
	}
	
	return self;
}


#pragma mark - Memory Management
- (void)dealloc {
	
	[self unregisterFromNotifications];
	
	patientMainContainer.delegate = nil;
	[patientMainContainer release], patientMainContainer = nil;
	
	[super dealloc];
}


#pragma mark - Orientation
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	return UIInterfaceOrientationIsLandscape(interfaceOrientation);
}


#pragma mark - View Lifecycle
-(void)viewDidLoad {
	[super viewDidLoad];
}

@end