//
//  ClinicalDataTableViewContainerView.m
//  PatientViewer
//
//  Created by Grant Oladipo on 2/1/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "PatientMainTableViewWrapper.h"

@interface PatientMainTableViewWrapper ()
-(void)refreshTableViews;
@end


@implementation PatientMainTableViewWrapper


#pragma mark -
#pragma mark Custom Actions
-(void)addTableView:(UITableView *)tableView position:(NSInteger)position {
	[tablesByIndex setObject:tableView forKey:[NSString stringWithFormat:@"%d", position]];
	[self refreshTableViews];
}

-(void)refreshTableViews {

	CGFloat y;
	CGFloat height = 0;
	NSString *key;
	NSInteger numberTableViews = 0;
	UITableView *tableView;
	UITableView *previousTableView = nil;
	
	for (UIView *subview in [self subviews]) {
		[subview removeFromSuperview];
	}
		
	for (NSInteger i=0; i<5; i++) {
		
		y=0;
		key = [NSString stringWithFormat:@"%d", i];
		tableView = [tablesByIndex objectForKey:key];
		
		if (tableView) {
			
			numberTableViews++;
			
			if (previousTableView) {
				y = previousTableView.frame.origin.y+previousTableView.frame.size.height+TablePadding;
			}
			
			[self addSubview:tableView];
			tableView.frame = CGRectMake(0, y, tableView.frame.size.width, tableView.frame.size.height);
			height += TablePadding + tableView.frame.size.height;
			previousTableView = tableView;
		}
	}
	
	self.frame = CGRectMake(self.frame.origin.x, self.frame.origin.y, self.frame.size.width, height);
}

-(void)removeTableView:(UITableView *)tableView position:(NSInteger)position {	
	[tablesByIndex removeObjectForKey:[NSString stringWithFormat:@"%d", position]];
	[self refreshTableViews];
}


#pragma mark -
#pragma mark Initialization
- (id)initWithCoder:(NSCoder *)decoder {
	
	self = [super initWithCoder:decoder];
	
	if (self) {
		tablesByIndex = [[NSMutableDictionary alloc] initWithCapacity:1];
	}
	
	return self;
}


#pragma mark -
#pragma mark Memory Managment
- (void)dealloc {
	
	[tablesByIndex release], tablesByIndex = nil;
	
	[super dealloc];
}

@end