//  PatientManager.m
//  PatientViewer
//
//  Created by Grant Oladipo on 12/15/10.
//  xxxxxxxxx xxxx xxxxxxx xxx xxxxxx xxxxxxxxxxxxxxxxxxxxxx

#import "Link.h"
#import "Patient.h"
#import "PatientManager.h"
#import "PatientParser.h"
#import "UserSession.h"

@implementation PatientManager


#pragma mark - Custom Accessors
-(PatientParser *)parser {
	return [[[PatientParser alloc] initWithDelegate:patientContainer] autorelease];	
}

-(void)patientsWithSearchString:(NSString *)theSearchString result:(id<PatientContainer>)thePatientContainer {
	
	[patientContainer release];
	patientContainer = [thePatientContainer retain];
	
	NSURL *url = [NSURL URLWithString:[NSString stringWithFormat:@"?searchString=%@", [theSearchString stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding]]
						relativeToURL:[[[[UserSession currentUserSession] links] objectForKey:UserSessionPatientSearchURILinkKey] href]];
	
	[self fetchResourceWithURL:url];
}


#pragma mark - Initialization
+(id)patientManager {
	
	PatientManager *patientManager = [[PatientManager alloc] init];
	
	return [patientManager autorelease];
}


#pragma mark - Memory Management
-(void)dealloc {
	
	[patientContainer release], patientContainer = nil;
	
	[super dealloc];
}

@end