//  ProblemManager.m
//  Patient Viewer
//
//  Created by Grant Oladipo on 12/15/10.
//  xxxxxxxxx xxxx xxxxxxx xxx xxxxxx xxxxxxxxxxxxxxxxxxxxxx

#import "Link.h"
#import "Patient.h"
#import "Problem.h"
#import "ProblemManager.h"
#import "ProblemParser.h"

@implementation ProblemManager


#pragma mark - Custom Accessors
-(ProblemParser *)parser {
	
	return [[[ProblemParser alloc] initWithDelegate:problemContainer] autorelease];
}

-(void)activeProblemsForPatient:(Patient *)patient result:(id<ProblemContainer>)theProblemContainer {
	
	[problemContainer release];
	problemContainer = [theProblemContainer retain];
	
	[self fetchResourceWithURL:[[[patient links] objectForKey:PatientProblemsLinkKey] href]];
}


#pragma mark - Initialization
+(id)problemManager {
	
	ProblemManager *problemManager = [[ProblemManager alloc] init];
	
	return [problemManager autorelease];
}


#pragma mark - Memory Management
-(void)dealloc {
	[problemContainer release], problemContainer = nil;
	
	[super dealloc];
}



@end