//
//  ResourceManager.m
//
//  Created by Grant Oladipo on 12/15/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "ConnectionFactory.h"
#import "ResourceManager.h"

@implementation ResourceManager

@synthesize parentElement;

#pragma mark - Custom Actions
-(id<Parser>)parser {
	//implemented in sublclasses
	return nil;
}

-(void)fetchResourceWithURL:(NSURL *)url  {
	
	NSLog(@"%@ Fetching from URL: %@", [self class], url);
	
	[theConnection release];
	theConnection = [[ConnectionFactory connection] retain];
	
	[theConnection getWithURL:url usingParser:[self parser]];
}


#pragma mark - Memory Management
-(void)dealloc {
	
	[theConnection release], theConnection = nil;
	
	[super dealloc];
}

@end