//
//  UserSessionManager.m
//  PatientViewer
//
//  Created by Grant Oladipo on 3/1/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "ApplicationProperty.h"
#import "LoginMain.h"
#import "UserSession.h"
#import "UserSessionManager.h"
#import "UserSessionParser.h"

@implementation UserSessionManager


#pragma mark - Custom Accessors
-(id<Parser>)parser {
	return [[[UserSessionParser alloc] initWithDelegate:loginMain] autorelease];
}

-(void)refreshUserSession:(LoginMain *)theLoginMain {
		
	[loginMain release];
	loginMain = [theLoginMain retain];
	
	[self fetchResourceWithURL:[NSURL URLWithString:[ApplicationProperty loginUrlString]]];
}


#pragma mark - Initialization
+(id)userSessionManager {
	
	UserSessionManager *userSessionManager = [[UserSessionManager alloc] init];
	
	return [userSessionManager autorelease];
}


#pragma mark - Memory Management
-(void)dealloc {

	[loginMain release], loginMain = nil;
	
	[super dealloc];
}

@end