//  UserSessionParser.m
//  PatientViewer
//
//  Created by Grant Oladipo on 5/3/11.
//  xxxxxxxxx xxxx xxxxxxx xxx xxxxxx xxxxxxxxx

#import "Link.h"
#import "LoginMain.h"
#import "ManagerUtility.h"
#import	"MHPUser.h"
#import "Resource.h"
#import "UserSession.h"
#import "UserSessionParser.h"

@implementation UserSessionParser


#pragma mark - Custom Actions
-(void)parseData:(NSData *)data {
	
	[xmlParser release];
	xmlParser = [[NSXMLParser alloc] initWithData:data];
	[xmlParser setDelegate:self];
	[xmlParser setShouldProcessNamespaces:YES];
	
	if (![xmlParser parse]) {
		NSLog(@"***Parsing UNSUCCESSFUL!");
		NSLog(@"Tried to parse:\n%@", [ManagerUtility prettyPrintXML:[[[NSString alloc] initWithData:data encoding:NSStringEncodingConversionAllowLossy] autorelease]]);
	}
}

#pragma mark - Initialization
-(id)initWithDelegate:(id)theDelegate {
	
	self = [super init];
	
	if (self) {
		delegate = [theDelegate retain];
	}
	
	return self;
}


#pragma mark - Memory Management
-(void)dealloc {
	
	[delegate release], delegate = nil;
	[xmlParser release], xmlParser = nil;	
	
	[super dealloc];
}


#pragma mark - NSXMLParserDelegate Methods
-(void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName {
}

-(void)parserDidEndDocument:(NSXMLParser *)parser {
	[delegate performLogin];
}

-(void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName attributes:(NSDictionary *)attributeDict {	
	
	if ([elementName isEqualToString:@"userSession"]) {

		[[UserSession currentUserSession] refreshWithAttributeDictionary:attributeDict];
		parentElement = [UserSession currentUserSession];

	} else if([elementName isEqualToString:@"mhpuser"]) {

		[mhpUser release];
		mhpUser = [[MHPUser alloc] initWithAttributeDictionary:attributeDict];
		[UserSession setMHPUser:mhpUser];
		
	} else if([elementName isEqualToString:@"link"]) {
		
		[link release];
		link = [[Link alloc] initWithAttributeDictionary:attributeDict];
		[parentElement addLink:link];
	}
}

@end