//  MainNavigationController.m
//  PatientViewer
//
//  Created by Grant Oladipo on 2/22/11.
//  xxxxxxxxx xxxx xxxxxxx xxx xxxxxx xxxxxxxxxxxxxxxxxxxxxx

@class Clipboard;
@class MedicationMain_iPad;
@class MedicationPanel_iPad;
@class LabMain_iPad;
@class LabPanel_iPad;
@class LoginMain_iPad;
@class NavigationSideBar;
@class PatientMain_iPad;
@class PatientPanel_iPad;

#pragma mark - Enums
typedef enum {
	MainNavigationPanelStateHidden,
	MainNavigationPanelStateDefault,
	MainNavigationPanelStateCollapsed,
	MainNavigationPanelStateFull,
	MainNavigationPanelStateExpanded
} MainNavigationPanelState;

typedef enum {
	MainNavigationViewModeLogin,
	MainNavigationViewModePatient,
	MainNavigationViewModeLabTest,
	MainNavigationViewModeMedication
} MainNavigationControllerViewMode;

@interface MainNavigationController : UIViewController {
	NSMutableDictionary *cacheDict;
	BOOL shouldClearCache;
}

#pragma mark - Panel Container Views
@property (nonatomic, retain, readonly) UIView *leftPanelV;
@property (nonatomic, retain, readonly) UIView *middlePanelV;
@property (nonatomic, retain, readonly) UIView *rightPanelV;


#pragma mark - Panel View Controller Handles
@property (nonatomic, retain, readonly) UIViewController *leftPanelVC;
@property (nonatomic, retain, readonly) UIViewController *middlePanelVC;
@property (nonatomic, retain, readonly) UIViewController *rightPanelVC;
@property (nonatomic, retain, readonly) UIViewController *newLeftPanelVC;
@property (nonatomic, retain, readonly) UIViewController *newMiddlePanelVC;
@property (nonatomic, retain, readonly) UIViewController *newRightPanelVC;


#pragma mark - Available View Controllers
@property (nonatomic, retain, readonly) Clipboard				*clipboard;
@property (nonatomic, retain, readonly) MedicationMain_iPad		*medicationMain;
@property (nonatomic, retain, readonly) MedicationPanel_iPad	*medicationPanel;
@property (nonatomic, retain, readonly) LabMain_iPad			*labMain;
@property (nonatomic, retain, readonly) LabPanel_iPad			*labPanel;
@property (nonatomic, retain, readonly) LoginMain_iPad			*loginMain;
@property (nonatomic, retain, readonly) NavigationSideBar		*navigationBar;
@property (nonatomic, retain, readonly) PatientMain_iPad		*patientMain;
@property (nonatomic, retain, readonly) PatientPanel_iPad		*patientPanel;


#pragma mark - Main Navigation State
@property (nonatomic) MainNavigationControllerViewMode viewMode;
@property (nonatomic) MainNavigationPanelState clipboardState;
@property (nonatomic) MainNavigationPanelState leftPanelState;
@property (nonatomic) MainNavigationPanelState middlePanelState;
@property (nonatomic) MainNavigationPanelState rightPanelState;


#pragma mark - Method Definitions
-(id)initWithViewMode:(MainNavigationControllerViewMode)startingViewMode;

-(void)setViewMode:(MainNavigationControllerViewMode)newViewMode animated:(BOOL)animated;

-(void)collapseMiddlePanel:(BOOL)animated;
-(void)expandMiddlePanel:(BOOL)animated;

-(void)showDisclaimer;

@end