//  MedicationPanel_iPad.m
//  PatientViewer
//
//  Created by Grant Oladipo on 4/12/11.
//  xxxxxxxxx xxxx xxxxxxx xxx xxxxxx xxxxxxxxx

#import "Link.h"
#import "Medication.h"
#import "MedicationPanelContainer.h"
#import "MedicationPanel_iPad.h"
#import "MetricsPusher.h"
#import "UserSession.h"
#import "SectionInfo.h"
#import "SectionHeaderView_iPad.h"

@implementation MedicationPanel_iPad

@synthesize customTVC;
@synthesize listTV;
@synthesize titleL;


#pragma mark - Custom Actions
-(NSInteger)getNumberOfRowsForGroupInSection:(NSInteger)section {
    return [super getNumberOfRowsForGroupInSection:section];
}

-(void)retrieveResults {
    [super retrieveResults];
}

-(void)processDidChangePatient:(NSNotification *)notification {
	shouldRefresh = YES;
}

#pragma mark - Initialization
-(id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
	
	self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
	
	if (self) {
		shouldRefresh = YES;
    }
	
    return self;
}


#pragma mark - MedicationPanelContainerDelegate Methos
-(void)medicationPanelContainerWillAddInpatientMedication:(MedicationPanelContainer *)container {
    [super medicationPanelContainerWillAddInpatientMedication:container];
}

-(void)medicationPanelContainerWillAddOutpatientMedication:(MedicationPanelContainer *)container {
    [super medicationPanelContainerWillAddOutpatientMedication:container];
}

-(void)medicationPanelContainerWillAddNonVAMedication:(MedicationPanelContainer *)container{
    [super medicationPanelContainerWillAddNonVAMedication:container];
}


-(void)medicationPanelContainer:(MedicationPanelContainer *)container didAddInpatientMedicationAtIndex:(NSInteger)index {
    [super medicationPanelContainer:container didAddInpatientMedicationAtIndex:index];
}

-(void)medicationPanelContainer:(MedicationPanelContainer *)container didAddOutpatientMedicationAtIndex:(NSInteger)index {	
    [super medicationPanelContainer:container didAddOutpatientMedicationAtIndex:index];
}


-(void)medicationPanelContainer:(MedicationPanelContainer *)container didAddNonVAMedicationAtIndex:(NSInteger)index {	
    [super medicationPanelContainer:container didAddNonVAMedicationAtIndex:index];
}

-(void)medicationPanelContainerFinishedLoadingInpatientMedications:(MedicationPanelContainer *)container {
}

-(void)medicationPanelContainerFinishedLoadingOutpatientMedications:(MedicationPanelContainer *)container {
}

-(void)medicationPanelContainerFinishedLoadingNonVAMedications:(MedicationPanelContainer *)container {
}

-(void)medicationPanelContainerFinishedLoadingMedications:(MedicationPanelContainer *)container  {
    [super medicationPanelContainerFinishedLoadingMedications:container];
}

#pragma mark - Memory Management
- (void)dealloc {
			
    [super dealloc];
}


#pragma mark - Orientation
-(BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation {
	return UIInterfaceOrientationIsLandscape(toInterfaceOrientation);
}



#pragma mark  - Section Header Delegate
-(void)sectionHeaderView:(SectionHeaderView*)sectionHeaderView sectionOpened:(NSInteger)sectionOpened {
	
	SectionInfo *sectionInfo = [sectionInfoArray objectAtIndex:sectionOpened];
	
	sectionInfo.open = YES;
    
    
    NSInteger countOfRowsToInsert = [self getNumberOfRowsForGroupInSection:sectionOpened];
    
    NSMutableArray *indexPathsToInsert = [[NSMutableArray alloc] init];
    for (NSInteger i = 0; i < countOfRowsToInsert; i++) {
        [indexPathsToInsert addObject:[NSIndexPath indexPathForRow:i inSection:sectionOpened]];
    }
    
    
    UITableViewRowAnimation insertAnimation;
    
    insertAnimation = UITableViewRowAnimationTop;
    
    UITableView *tableView = self.listTV;
    
    [tableView beginUpdates];
    
    [tableView insertRowsAtIndexPaths:indexPathsToInsert withRowAnimation:insertAnimation];
    [tableView endUpdates];
    
    [indexPathsToInsert release];
}


-(void)sectionHeaderView:(SectionHeaderView*)sectionHeaderView sectionClosed:(NSInteger)sectionClosed {
    
    
	SectionInfo *sectionInfo = [sectionInfoArray objectAtIndex:sectionClosed];
	
    sectionInfo.open = NO;
    NSInteger countOfRowsToDelete = [self getNumberOfRowsForGroupInSection:sectionClosed];
    
    if (countOfRowsToDelete > 0) {
        NSMutableArray *indexPathsToDelete = [[NSMutableArray alloc] init];
        for (NSInteger i = 0; i < countOfRowsToDelete; i++) {
            [indexPathsToDelete addObject:[NSIndexPath indexPathForRow:i inSection:sectionClosed]];
        }
        [self.listTV beginUpdates];
        [self.listTV deleteRowsAtIndexPaths:indexPathsToDelete withRowAnimation:UITableViewRowAnimationTop];
        
        [self.listTV endUpdates];
        
        [indexPathsToDelete release];
    }
}

-(UIView*)tableView:(UITableView*)tableView viewForHeaderInSection:(NSInteger)section {
    
    
    SectionInfo *sectionInfo = [sectionInfoArray objectAtIndex:section];
    if (!sectionInfo.headerView) {

        NSString *groupName = [sectionInfo groupName];
        sectionInfo.headerView = [[[SectionHeaderView_iPad alloc] initWithFrame:CGRectMake(0.0, 0.0, self.listTV.bounds.size.width, self.listTV.sectionHeaderHeight) title:groupName section:section delegate:self] autorelease];
        if (section==0) {
            sectionInfo.headerView.disclosureButton.selected = YES;
        } else {
            sectionInfo.headerView.disclosureButton.selected = NO;
        }
        
    }
    
    return sectionInfo.headerView;
    
}

#pragma mark - UITableViewDataSource Methods
//-(UIView *)tableView:(UITableView *)tableView viewForHeaderInSection:(NSInteger)section {
//    
//    if([self.medicationPanelContainer hasMedications]){
//        UILabel *title = [[UILabel alloc] initWithFrame:CGRectMake(15, 4, 200, 22)];
//        
//        title.backgroundColor = [UIColor clearColor];
//        title.font = [UIFont fontWithName:@"Arial-BoldMT" size:15];
//        title.textColor = [UIColor colorWithRawValuesForRed:24 green:38 blue:86 alpha:1.0];
//        title.shadowColor = [UIColor whiteColor];
//        title.shadowOffset = CGSizeMake(0, 1);
//        
//        title.text = [self tableView:tableView titleForHeaderInSection:section];
//        
//        UIImageView *header = [[[UIImageView alloc] initWithImage:[UIImage imageNamed:@"PatientPanel_iPad-subtitle.png"]] autorelease];
//        
//        [header addSubview:title];
//        
//        [title release];
//        
//        return  header;
//        
//    } else{
//        return  nil;
//	}	
//}

-(void)configureCell:(UITableViewCell *)cell forIndexPath:(NSIndexPath *)indexPath {
    

	if ([cell.reuseIdentifier isEqualToString:(NSString *)NoMedicationsCellIdentifier]) {
		cell.textLabel.text = @"No Medication Data";
	} else {
		
		Medication *medication = [self getMedicationAtIndexPath:indexPath];
		UILabel *label = (UILabel *)[cell viewWithTag:1];
		label.text = [medication drugName];

		label = (UILabel *)[cell viewWithTag:2];
		label.text = [medication displayQuantity];
			
		label = (UILabel *)[cell viewWithTag:3];
		label.text = [medication lastFilledDate];
		
		label = (UILabel *)[cell viewWithTag:4];
		label.text = [medication sig];
        
        label = (UILabel *)[cell viewWithTag:5];
        
        if ([[medication status] length] > 1) {
            label.text =[[medication status] substringToIndex:1];
            if ([label.text caseInsensitiveCompare:@"A"] == NSOrderedSame) {
                label.textColor = [UIColor blackColor];
                label.font = [UIFont systemFontOfSize:17];
            } else {
                label.textColor = [UIColor blueColor];
                label.font = [UIFont boldSystemFontOfSize:17];
            }
        } else {
            label.text = @"";
        }


	}
}

-(NSString *)cellIdentifierForContainer:(MedicationPanelContainer *)container {
	
	if ([container hasMedications]) {
		return (NSString *)MedicationCellIdentifier;
    } else {
		return (NSString *)NoMedicationsCellIdentifier;
    }
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    numberOfSections = 3;
	return numberOfSections;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {

	NSInteger result = 0;
    
    
        if ([self isInpatient]) {
            
            switch (section) {
                case inpatientIndexForInpatient:
                    result = self.numberOfInpatientMedications;
                    break;
                case nonVAIndexForInpatient:
                    result = self.numberOfNonVAMedications;
                    break;
                case outpatientIndexForInpatient:
                    result = self.numberOfOutpatientMedications;
                    break;
                    
                default:
                    break;
            }
            
            
        } else {

            switch (section) {
                case inpatientIndexForOutpatient:
                    result = self.numberOfInpatientMedications;
                    break;
                case nonVAIndexForOutpatient:
                    result = self.numberOfNonVAMedications;
                    break;
                case outpatientIndexForOutpatient:
                    result = self.numberOfOutpatientMedications;
                    break;
                    
                default:
                    break;
            }
            
            
        }
        
    SectionInfo *sectionInfo = [sectionInfoArray objectAtIndex:section];
    
    return sectionInfo.open ?result: 0;
}   


- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
	static NSString *DetailedMedicationCellNibName = @"DetailedMedicationCell";
	
	NSString *cellIdentifier = [self cellIdentifierForContainer:self.medicationPanelContainer];
	
	UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellIdentifier];
    
	if (cell == nil) {
		
		if ([cellIdentifier isEqualToString:MedicationCellIdentifier]) {

			[[NSBundle bundleForClass:[self class]] loadNibNamed:DetailedMedicationCellNibName owner:self options:nil];
			cell = [[self.customTVC retain] autorelease];
			self.customTVC = nil;
			
		} else {
			cell =  [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:NoMedicationsCellIdentifier] autorelease];
		}
	}
    
	[self configureCell:cell forIndexPath:indexPath];
	
	return cell;
}


#pragma mark - UITableViewDelegate Method
-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	

	if ([self.medicationPanelContainer hasMedications]) {

        
		Medication *medication = [self getMedicationAtIndexPath:indexPath];
		
        
		NSDictionary *tagDict = [NSDictionary dictionaryWithObjectsAndKeys:[[[[medication links] objectForKey:ResourceSelfLinkKey] href] absoluteString], 
								 @"Medication.uri", nil];
		
		[MetricsPusher reportMetricsWithUserEventValue:@"SelectMedicationOnMedicationViewer" tagDictionary:tagDict];
		
		[UserSession setSelectedMedication:medication];
	}
}

-(NSString *)titleForHeaderInSection:(NSInteger)section {
    return [super titleForHeaderInSection:section];
}




#pragma mark - View Lifecycle
-(void)viewDidAppear:(BOOL)animated {
		
	[super viewDidAppear:animated];
	
	[MetricsPusher reportMetricsWithUserEventValue:@"LaunchMedicationViewer" tagDictionary:nil];
	
	if (shouldRefresh) {
		[self retrieveResults];
		shouldRefresh=NO;
	}
}



- (void)viewDidLoad {
	[super viewDidLoad];
    
    static NSString *MedicationPanelTitle = @"Medications";
    
    self.title = MedicationPanelTitle;
	self.titleL.text = MedicationPanelTitle;
}

- (void)viewDidUnload {
	
	[customTVC release], customTVC = nil;
	[listTV release], listTV = nil;
	[titleL release], titleL = nil;
	
	[super viewDidUnload];
}

@end