//  AppDelegate_iPhone.m
//  PatientViewer
//
//  Created by Grant Oladipo on 12/14/10.
//  xxxxxxxxx xxxx xxxxxxx xxx xxxxxx xxxxxxxxxxxxxxxxxxxxxx

#import "AppDelegate_iPhone.h"
#import "LoginMain_iPhone.h"
#import "PatientMain_iPhone.h"
#import "PatientPanel_iPhone.h"
#import "LabPanel_iPhone.h"

@implementation AppDelegate_iPhone

@synthesize tabBarController;

#pragma mark - View Creation
-(void)showLogin { 
	
    LoginMain_iPhone *loginVC = [[LoginMain_iPhone alloc] initWithNibName:@"LoginMain_iPhone" bundle:[NSBundle bundleForClass:[self class]]];
    
    UINavigationController *loginNavigationController = [[UINavigationController alloc] initWithRootViewController:loginVC];
    [loginVC release];
    
    [tabBarController presentModalViewController:loginNavigationController animated:NO];
    [loginNavigationController release];
}

-(void)createViewStructure {
	
	tabBarController.viewControllers = nil;
		
    PatientMain_iPhone* patientSummaryViewController_iPhone = [[PatientMain_iPhone alloc] initWithNibName:@"PatientMain_iPhone" bundle:[NSBundle bundleForClass:[self class]]];
	
	
    PatientPanel_iPhone* patientPanelViewController_iPhone = [[PatientPanel_iPhone alloc] initWithNibName:@"PatientPanel_iPhone" bundle:[NSBundle bundleForClass:[self class]]];
	
    patientSummaryViewController_iPhone.title = @"Patient Summary";
    
    LabPanel_iPhone* labTestPanelViewController_iPhone =[[LabPanel_iPhone alloc] initWithNibName:@"LabPanel_iPhone" bundle:[NSBundle bundleForClass:[self class]]];
    labTestPanelViewController_iPhone.title = @"Lab Results";
	
    
    UINavigationController *patientSummaryNavigationController = [[UINavigationController alloc] initWithRootViewController:patientSummaryViewController_iPhone];
    patientSummaryNavigationController.tabBarItem.image = [UIImage imageNamed:@"icon_retina_patient.png"];
    
  
    
    UINavigationController *labTestPanelNavigationController = [[UINavigationController alloc] initWithRootViewController:labTestPanelViewController_iPhone];
    labTestPanelNavigationController.tabBarItem.image = [UIImage imageNamed:@"icon_retina_labviewer.png"];
    

    
    NSArray* viewControllers = [NSArray arrayWithObjects:patientPanelViewController_iPhone, patientSummaryNavigationController, labTestPanelNavigationController, nil];
    tabBarController.viewControllers = viewControllers;
    
	
	
    [patientSummaryViewController_iPhone release];
    [patientPanelViewController_iPhone release];
    [labTestPanelViewController_iPhone release];
    
    [patientSummaryNavigationController release];
    [labTestPanelNavigationController release];
    
    [[[tabBarController.tabBar items] objectAtIndex:PatientLabViewTab] setEnabled:NO];
    [[[tabBarController.tabBar items] objectAtIndex:PatientSummaryTab] setEnabled:NO];
	
	[self.tabBarController setSelectedViewController:[[self.tabBarController viewControllers] objectAtIndex:PatientSearchTab]]; 
    
    
}


-(void)processShouldWipeData:(NSNotification *)notification {
	[self showLogin];
	
	[self createViewStructure];

}

#pragma mark - Application lifecycle
- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {    
	
	self.tabBarController = [[[UITabBarController alloc] init] autorelease];
    tabBarController.delegate = self;

    [self createViewStructure];
       
	[self.window addSubview:tabBarController.view];

	[self showLogin];

   	return [super application:application didFinishLaunchingWithOptions:launchOptions];
}


#pragma mark Notificaitons
-(void)registerForNotifications {
	NSNotificationCenter *defaultCenter = [NSNotificationCenter defaultCenter];
	[defaultCenter addObserver:self selector:@selector(processShouldWipeData:) name:ConnectionShouldWipeData object:nil];
	
}

-(void)unregisterForNotifications {
	[[NSNotificationCenter defaultCenter] removeObserver:self];
}

#pragma mark - Initialization
-(id)init {
	
	self = [super init];
	
	if (self) {
		[self registerForNotifications];
	}
	
	return self;
}

#pragma mark - Memory Management
-(void)dealloc {
	[self unregisterForNotifications];
	[tabBarController release], tabBarController = nil;
	
	[super dealloc];
}
@end