//
//  PatientSummaryMedicationsViewController.m
//  PatientViewer
//
//  Created by Tea, Matt on 4/11/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "Medication.h"
#import "MedicationMain_iPhone.h"
#import "Patient.h"
#import "UserSession.h"

@implementation MedicationMain_iPhone

#pragma mark - Custom Actions
-(void)refreshTitleView {
    Patient *thePatient = [UserSession selectedPatient];
    
    nameL.text =    [thePatient displayName];
    ssnL.text =     [thePatient ssn];
    dobL.text =     [NSString stringWithFormat:@"%@ (%@)",[thePatient dateOfBirth], [thePatient age]];
    
    if ([thePatient gender]) { 
        genderL.text = [[thePatient gender] substringWithRange:NSMakeRange(0, 1)];
    }
}

-(void)changeStatusColor {
    Medication *medication = [UserSession selectedMedication];
    
    if ([[medication status] isEqualToString:@"ACTIVE"]) {
        statusL.textColor = [UIColor blackColor];
        statusL.font = [UIFont systemFontOfSize:14];
    } else {
        statusL.textColor = [UIColor blueColor];
        statusL.font = [UIFont boldSystemFontOfSize:14];
    }
}

#pragma mark - Orientation
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}



#pragma mark - View lifecycle
-(void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
    [self refreshTitleView];
    [self populateData];
}

-(void)viewDidLoad {
    [super viewDidLoad];
    contentSV.contentSize = CGSizeMake(320, 550);
    medicationDetailTV.layer.borderWidth = 1.0;
    medicationDetailTV.layer.borderColor = [UIColor colorWithRawValuesForRed:175 green:128 blue:29 alpha:1.0].CGColor;
	
	self.navigationItem.rightBarButtonItem = [[[UIBarButtonItem alloc] initWithTitle:@"Feedback" 
																			   style:UIBarButtonItemStylePlain 
																			  target:[AppDelegate class] 
																			  action:@selector(launchFeedback)] autorelease];
}

@end