//  SearchPanelViewController_iPhone.m
//  PatientViewer
//
//  Created by Matt Tea on 3/10/11.
//  Copyright 2011 Agielx Technologies. All rights reserved.

#import "AppDelegate_iPhone.h"
#import "LabPanelContainer.h"
#import "LabPanel_iPhone.h"
#import "Patient.h"
#import "PatientMain_iPhone.h"
#import "PatientPanelContainer.h"
#import "PatientPanel_iPhone.h"
#import "UserSession.h"

@implementation PatientPanel_iPhone



#pragma mark - Custom Methods
-(void)performClear {
    
	[UserSession setSelectedPatient:nil];
    
    [[[self.tabBarController.tabBar items] objectAtIndex:PatientSummaryTab] setEnabled:NO];
    [[[self.tabBarController.tabBar items] objectAtIndex:PatientLabViewTab] setEnabled:NO];
    
	
	[patientPanelContainer removeAllObjects];
	numberOfSections = 0;
	[self.listTV reloadData];
}

-(NSString*)getPatientCellName {
    return @"PatientCell_iPhone";
}

-(NSString*)getNoPatientCellName {
    return @"NoPatientCell_iPhone";
}

-(UIImage*)getSectionHeaderImage {
    return [UIImage imageNamed:@"PatientPanel_iPhone-subtitle.png"];
}

#pragma mark - Orientation
-(BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	return UIInterfaceOrientationIsPortrait(interfaceOrientation);
}

#pragma mark - UITableViewDelegate Methods
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {

	[super tableView:tableView didSelectRowAtIndexPath:indexPath];
	
    if ([patientPanelContainer hasPatients]) {
        [UserSession setSelectedPatient:[patientPanelContainer patientAtIndex:indexPath.row]];
        
        [self.tabBarController setSelectedViewController:[[self.tabBarController viewControllers] objectAtIndex:PatientSummaryTab]];         
    
        
        [[[self.tabBarController.tabBar items] objectAtIndex:PatientSummaryTab] setEnabled:YES];
        [[[self.tabBarController.tabBar items] objectAtIndex:PatientLabViewTab] setEnabled:YES];
   
    }
}



-(IBAction)launchFeedback:(id)sender {
	[AppDelegate launchFeedback];
}



#pragma mark - View Lifecycle
-(void)viewDidLoad {	

	[super viewDidLoad];
        
    self.tabBarItem.image = [UIImage imageNamed:@"icon_retina_search.png"];
}

@end