//
//  ProblemPanel_iPhone.m
//  PatientViewer
//
//  Created by Tea, Matt on 6/20/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "ProblemPanel_iPhone.h"
#import "UserSession.h"
#import "Patient.h"

@implementation ProblemPanel_iPhone

@synthesize patientMainContainer;
@synthesize hasProblems;

#pragma mark - Custom Actions
-(void)refreshTitleView {
    Patient *thePatient = [UserSession selectedPatient];
    
    nameL.text =    [thePatient displayName];
    ssnL.text =     [thePatient ssn];
    dobL.text =     [NSString stringWithFormat:@"%@ (%@)",[thePatient dateOfBirth], [thePatient age]];
    
    if ([thePatient gender]) { 
        genderL.text = [[thePatient gender] substringWithRange:NSMakeRange(0, 1)];
    }
}



#pragma mark - Orientation
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    
	if (interfaceOrientation == UIInterfaceOrientationPortrait || interfaceOrientation == UIInterfaceOrientationPortraitUpsideDown) {
		return YES;
	}
    return NO;
}


#pragma mark - Memory Management
-(void)dealloc {
    [patientMainContainer release], patientMainContainer = nil;
    [super dealloc];
}


#pragma mark - UITableViewDataSource Methods
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return [patientMainContainer numberOfProblems];
}

-(void)configureCell:(UITableViewCell *)cell forTableView:(UITableView *)tableView atIndexPath:(NSIndexPath *)indexPath {
  
    if(hasProblems) {
        
        Problem *problem = [patientMainContainer problemAtIndex:indexPath.row];
        cell.textLabel.text = [[problem description] capitalizedString];
        cell.contentView.backgroundColor = [UIColor colorWithRawValuesForRed:240 green:240 blue:240 alpha:1.0];    
    } else {    
        cell.textLabel.text = @"No Data Found";
        cell.contentView.backgroundColor = [UIColor colorWithRawValuesForRed:240 green:240 blue:240 alpha:1.0];
    }
}


- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
	static NSString *CellIdentifier = @"Cell";
	UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	
	if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleValue1 reuseIdentifier:CellIdentifier];
    }
	
    
	[self configureCell:cell forTableView:tableView atIndexPath:indexPath];
	
	return cell;
    
}    

#pragma mark - View lifecycle
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
    
    [self refreshTitleView];
    [listTV reloadData];
}

-(void)viewDidLoad {
	self.navigationItem.rightBarButtonItem = [[[UIBarButtonItem alloc] initWithTitle:@"Feedback" 
																			   style:UIBarButtonItemStylePlain 
																			  target:[AppDelegate class] 
																			  action:@selector(launchFeedback)] autorelease];
}



@end